package com.brilliance.swift.exception;

public class CommonRuntimeException extends RuntimeException {

    static {
        CommonRuntimeException.class.getName();
    }

    public CommonRuntimeException(String msg) {
        super(msg);
    }

    public CommonRuntimeException(String msg, Throwable cause) {
        super(msg, cause);
    }


    public String getMessage() {
        return buildMessage(super.getMessage(), getCause());
    }


    public Throwable getRootCause() {
        return getRootCause(this);
    }

    private String buildMessage(String message, Throwable cause) {
        if (cause == null) {
            return message;
        }
        StringBuilder sb = new StringBuilder(64);
        if (message != null) {
            sb.append(message).append("; ");
        }
        sb.append("nested exception is ").append(cause);
        return sb.toString();
    }

    private Throwable getRootCause(Throwable original) {
        if (original == null) {
            return null;
        }
        Throwable rootCause = null;
        Throwable cause = original.getCause();
        while (cause != null && cause != rootCause) {
            rootCause = cause;
            cause = cause.getCause();
        }
        return rootCause;
    }

}
