package com.brilliance.swift.mt2SwiftDto.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.prowidesoftware.swift.model.field.Field21;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT900;
import com.prowidesoftware.swift.model.mt9xx.MT910;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt054001Parse21Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = context.get(BankToCustomerDebitCreditNotification.class);
            if(context.get(AbstractMT.class).getMessageType().equals("900")){
                MT900 mt900 = (MT900) context.get(AbstractMT.class);
                Field21 field21 = mt900.getField21();
                if(field21!=null){
                    bankToCustomerDebitCreditNotification.getTxnRef().setEndToEndId(field21.getValue());
                }
            }else {
                MT910 mt910 = (MT910) context.get(AbstractMT.class);
                Field21 field21 = mt910.getField21();
                if(field21!=null){
                    bankToCustomerDebitCreditNotification.getTxnRef().setEndToEndId(field21.getValue());
                }
            }
        }catch (Exception e){
            throw new SwiftException("ERROR", e.getMessage());
        }


    }
}
