package com.brilliance.swift.mt2SwiftDto.camt054001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field56A;
import com.prowidesoftware.swift.model.field.Field56D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt9xx.MT910;

/**
 * @author zh
 * @create 2022-04-24 14:59
 */
public class Camt054001Parse56aField extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = context.get(BankToCustomerDebitCreditNotification.class);
            if(context.get(AbstractMT.class).getMessageType().equals("910")){
                MT910 mt910 = (MT910) context.get(AbstractMT.class);
                PartyDto partyDto = null;
                if(mt910.getField56A()!=null){
                    Field56A field56A = mt910.getField56A();
                    partyDto = new PartyDto();
                    if (StringUtil.isNotEmpty(field56A.getAccount())) {
                        partyDto = buildPartyAccount(partyDto, field56A.getLine(1));
                    }
                    partyDto.setPartyBic(field56A.getBIC());
                }else if(mt910.getField56D()!=null){
                    Field56D field56D = mt910.getField56D();
                    partyDto = new PartyDto();
                    if (StringUtil.isNotEmpty(field56D.getAccount())) {
                        partyDto = buildPartyAccount(partyDto, field56D.getLine(1));
                    }
                    partyDto.setPartyName(field56D.getNameAndAddressLine1());
                    if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine2())) {
                        partyDto.addAddress(field56D.getNameAndAddressLine2());
                    }
                    if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine3())) {
                        partyDto.addAddress(field56D.getNameAndAddressLine3());
                    }
                    if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine4())) {
                        partyDto.addAddress(field56D.getNameAndAddressLine4());
                    }
                    partyDto.setPartyAcct(buildPartyAccount(field56D.getAccount()));
                }
                if(partyDto!=null){
                    bankToCustomerDebitCreditNotification.setIntrmyAgtParty(partyDto);
                }
            }
        }catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
