package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field53A;
import com.prowidesoftware.swift.model.field.Field53B;
import com.prowidesoftware.swift.model.field.Field53D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse53Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField53A() != null) {
                Field53A field53A = mt103.getField53A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field53A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field53A.getLine(1));
                }
                partyDto.setPartyBic(field53A.getBIC());
            } else if (mt103.getField53B() != null) {
                Field53B field53B = mt103.getField53B();
                if (StringUtil.isNotEmpty(field53B.getAccount())) {
                    customerCreditTransfer.setSettleAccount(buildPartyAccount(field53B.getLine(1)));
                }
            } else if (mt103.getField53D() != null) {
                Field53D field53D = mt103.getField53D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field53D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field53D.getLine(1));
                }
                partyDto.setPartyName(field53D.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field53D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field53D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field53D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field53D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field53D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field53D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setInstgAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
