package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field54A;
import com.prowidesoftware.swift.model.field.Field54B;
import com.prowidesoftware.swift.model.field.Field54D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse54Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103)context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField54A() != null) {
                Field54A field54A = mt103.getField54A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field54A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field54A.getLine(1));
                }
                partyDto.setPartyBic(field54A.getBIC());
            } else if (mt103.getField54B() != null) {
                Field54B field54B = mt103.getField54B();
                //TODO
            } else if (mt103.getField54D() != null) {
                Field54D field54D = mt103.getField54D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field54D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field54D.getLine(1));
                }
                partyDto.setPartyName(field54D.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field54D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field54D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field54D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field54D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field54D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field54D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setInstdAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
