package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field56A;
import com.prowidesoftware.swift.model.field.Field56C;
import com.prowidesoftware.swift.model.field.Field56D;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse56Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField56A() != null) {
                Field56A field56A = mt103.getField56A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field56A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field56A.getLine(1));
                }
                partyDto.setPartyBic(field56A.getBIC());
            } else if (mt103.getField56C() != null) {
                Field56C field56C = mt103.getField56C();
                partyDto = new PartyDto();
                partyDto = buildPartyAccount(partyDto, field56C.getValue());
            } else if (mt103.getField56D() != null) {
                Field56D field56D = mt103.getField56D();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field56D.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field56D.getLine(1));
                }
                partyDto.setPartyName(field56D.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine2())) {
                    partyDto.addAddress(field56D.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine3())) {
                    partyDto.addAddress(field56D.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field56D.getNameAndAddressLine4())) {
                    partyDto.addAddress(field56D.getNameAndAddressLine4());
                }
            }
            if (partyDto != null) {
                customerCreditTransfer.setIntrmyAgtParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
