package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field59;
import com.prowidesoftware.swift.model.field.Field59A;
import com.prowidesoftware.swift.model.field.Field59F;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse59Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            PartyDto partyDto = null;
            if (mt103.getField59() != null) {
                Field59 field59 = mt103.getField59();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field59.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field59.getLine(1));
                }
                partyDto.setPartyName(field59.getNameAndAddressLine1());
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine2())) {
                    partyDto.addAddress(field59.getNameAndAddressLine2());
                }
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine3())) {
                    partyDto.addAddress(field59.getNameAndAddressLine3());
                }
                if (StringUtil.isNotEmpty(field59.getNameAndAddressLine4())) {
                    partyDto.addAddress(field59.getNameAndAddressLine4());
                }
            } else if (mt103.getField59A() != null) {
                Field59A field59A = mt103.getField59A();
                partyDto = new PartyDto();
                if (StringUtil.isNotEmpty(field59A.getAccount())) {
                    partyDto = buildPartyAccount(partyDto, field59A.getLine(1));
                }
                partyDto.setPartyBic(field59A.getBIC());
            } else if (mt103.getField59F() != null) {
                Field59F field59F = mt103.getField59F();
                //TODO
            }
            if (partyDto != null) {
                customerCreditTransfer.setCreditParty(partyDto);
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
