package com.brilliance.swift.mt2SwiftDto.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.InstructionForCreditAgent;
import com.brilliance.swift.vo.common.InstructionForNextAgent;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt1xx.MT103;

public class Pacs00801Parse72Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoCustomerCreditTransfer customerCreditTransfer = context.get(VoCustomerCreditTransfer.class);
            MT103 mt103 = (MT103) context.get(AbstractMT.class);
            Field72 field72 = mt103.getField72();
            if (field72 != null) {
                String field72Value = field72.getValue().replace("\r\n//", "");
                String[] lines = field72Value.split("\r\n");
                for (int i=0; i<lines.length; i++) {
                    String line = lines[i];
                    if (line.startsWith("/INS/")) {
                        PartyDto party = new PartyDto();
                        String lineStr = line.substring(5);
                        if (SwiftTransferUtil.isBIC(lineStr)) {
                            party.setPartyBic(lineStr);
                        } else {
                            party.setPartyName(lineStr);
                        }
                        customerCreditTransfer.setPreInstgAgtParty(party);
                    }
                    if (line.startsWith("/ACC/")) {
                        if (customerCreditTransfer.getInstForCrdAgt() == null) {
                            InstructionForCreditAgent instForCrdAgt = new InstructionForCreditAgent();
                            instForCrdAgt.setInstrInf(line.substring(5));
                            customerCreditTransfer.setInstForCrdAgt(instForCrdAgt);
                        }
                    }
                    if (line.startsWith("/REC/")) {
                        InstructionForNextAgent instForNxtAgt = new InstructionForNextAgent();
                        instForNxtAgt.setInstrInf(line.substring(5));
                        customerCreditTransfer.setInstForNxtAgt(instForNxtAgt);
                    }
                }
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
