package com.brilliance.swift.mt2SwiftDto.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.prowidesoftware.swift.model.field.Field20;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt2xx.MT202;
import com.prowidesoftware.swift.model.mt2xx.MT202COV;

public class Pacs009001Parse20Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = context.get(VoFinancialInstitutionCreditTransfer.class);
            Field20 field20 = getField20();
            if (field20 != null) {
                financialInstitutionCreditTransfer.getSwiftHeader().setMessageId(field20.getValue());
                financialInstitutionCreditTransfer.getTxnRef().setInstructionId(field20.getValue());
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }

    private Field20 getField20() {
        if (isCov()) {
            MT202COV mt202Cov = (MT202COV)context.get(AbstractMT.class);
            return mt202Cov.getField20();
        } else {
            MT202 mt202 = (MT202)context.get(AbstractMT.class);
            return mt202.getField20();
        }
    }
}
