package com.brilliance.swift.mt2SwiftDto.pacs009001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2SwiftDto.AbstractMt2SwiftDtoParseFields;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.prowidesoftware.swift.model.field.Field21;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import com.prowidesoftware.swift.model.mt2xx.MT202;
import com.prowidesoftware.swift.model.mt2xx.MT202COV;

public class Pacs009001Parse21Field extends AbstractMt2SwiftDtoParseFields {
    @Override
    public void parseFields() throws SwiftException {
        try {
            VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = context.get(VoFinancialInstitutionCreditTransfer.class);
            Field21 field21 = getField21();
            if (field21 != null) {
                if (Mx2MtConstants.MT_21_DEFAULT_VALUE.equals(field21.getValue())) {
                    financialInstitutionCreditTransfer.getTxnRef().setEndToEndId(Mx2MtConstants.MX_END_TO_END_ID_DEFAULT_VALUE);
                } else {
                    financialInstitutionCreditTransfer.getTxnRef().setEndToEndId(field21.getValue());
                }
            }
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }

    private Field21 getField21() {
        if (isCov()) {
            MT202COV mt202Cov = (MT202COV)context.get(AbstractMT.class);
            return mt202Cov.getField21();
        } else {
            MT202 mt202 = (MT202)context.get(AbstractMT.class);
            return mt202.getField21();
        }
    }
}
