package com.brilliance.swift.mt2mx.camt029001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxParseField;

import java.util.HashMap;
import java.util.Map;

public abstract class AbstractMt2MxCamt029001ParseField extends AbstractMt2MxParseField {

    protected Map<String, Object> appHdrMaps = null;

    protected Map<String, Object> assgnmtMaps = null;

    protected Map<String, Object> stsMaps = null;

    protected Map<String, Object> cxlDtlsMaps = null;

    @Override
    public void initJsonMaps() {
        super.initJsonMaps();
        appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        Map<String, Object> rsltnOfInvstgtnMaps = (Map<String, Object>)jsonMaps.get("rsltnOfInvstgtn");
        assgnmtMaps = (Map<String, Object>)rsltnOfInvstgtnMaps.get("assgnmt");
        if(rsltnOfInvstgtnMaps.containsKey("sts")){
            stsMaps = (Map<String, Object>)rsltnOfInvstgtnMaps.get("sts");
        }else {
            stsMaps = new HashMap<>();
            rsltnOfInvstgtnMaps.put("sts",stsMaps);
        }
        JSONArray cxlDtlsJsonArray = (JSONArray) rsltnOfInvstgtnMaps.get("cxlDtls");
        cxlDtlsMaps = (Map<String, Object>)cxlDtlsJsonArray.get(0);
    }
    public Map<String, Object> getTxInfAndStsMaps(){
        Map<String, Object> txInfAndStsMaps = null;
        JSONArray txInfAndStsJsonArray = null;
        if(cxlDtlsMaps.containsKey("txInfAndSts")){
            txInfAndStsJsonArray = (JSONArray) cxlDtlsMaps.get("txInfAndSts");
            if (txInfAndStsJsonArray.size()>0) {
                txInfAndStsMaps = (Map<String, Object>)txInfAndStsJsonArray.get(0);
            } else {
                txInfAndStsMaps = new HashMap<>();
                txInfAndStsJsonArray.add(txInfAndStsMaps);
            }
        }else {
            txInfAndStsJsonArray = new JSONArray();
            txInfAndStsMaps = new HashMap<>();
            cxlDtlsMaps.put("txInfAndSts",txInfAndStsJsonArray);
            txInfAndStsJsonArray.add(txInfAndStsMaps);
        }
        return txInfAndStsMaps;
    }
}
