package com.brilliance.swift.mt2mx.camt029001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field11R;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import javax.xml.datatype.XMLGregorianCalendar;
import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class Camt029001Parse11RField extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "11R";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag != null) {
                Field11R field11R = (Field11R)tag.asField();
                Date date = DateUtil.parseDate("20"+field11R.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                Map<String, Object> txInfAndStsMaps = getTxInfAndStsMaps();
                Map<String, Object> orgnlGrpInfMaps = null;
                if(txInfAndStsMaps.containsKey("orgnlGrpInf")){
                    orgnlGrpInfMaps = (Map<String, Object>)txInfAndStsMaps.get("orgnlGrpInf");
                }else {
                    orgnlGrpInfMaps = new HashMap<>();
                    txInfAndStsMaps.put("orgnlGrpInf",orgnlGrpInfMaps);
                }
                String mtType = field11R.getMT();
                String mxType = getMxType(mtType);
                orgnlGrpInfMaps.put("orgnlMsgNmId",mxType);
                orgnlGrpInfMaps.put("orgnlCreDtTm",dateStr+"T00:00:00+00:00");
                orgnlGrpInfMaps.put("orgnlMsgId", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
            }
        } catch (ParseException e) {
            throw  new SwiftException("ERROR", e.getMessage());
        }
    }
}
