package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field76;
import com.prowidesoftware.swift.model.field.Field77A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.Map;

public class Camt029001Parse77AField extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "77A";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag77A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag77A != null) {
            Map<String, Object> txInfAndStsMaps = getTxInfAndStsMaps();
            Field77A field77A = (Field77A)tag77A.asField();
            String String77A = field77A.getValue().replace("\r\n//", "").replace("\r\n","");
            int index = String77A.indexOf("/UETR/");
            if(index>-1){
                String uetr = String77A.substring(index+6);
                txInfAndStsMaps.put("orgnlUETR",uetr);
            }
        }
    }
}
