package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse26TField extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "26T";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag26T = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag26T != null) {
            String value = ":26T:" + tag26T.getValue();
            Map<String, Object> purpMaps = null;
            if (cdtTrfTxInfMaps.containsKey("purp")) {
                purpMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("purp");
            } else {
                purpMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("purp", purpMaps);
            }
            purpMaps.put("prtry", value);
        }
    }
}
