package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse32AField extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag != null) {
                Field32A field32A = (Field32A)tag.asField();
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                cdtTrfTxInfMaps.put("intrBkSttlmDt", dateStr);
                Map<String, Object> intrBkSttlmAmtMaps = new HashMap<>();
                intrBkSttlmAmtMaps.put("value", field32A.amount());
                intrBkSttlmAmtMaps.put("ccy", field32A.getCurrency());
                cdtTrfTxInfMaps.put("intrBkSttlmAmt", intrBkSttlmAmtMaps);
            }
        } catch (ParseException e) {
            throw  new SwiftException("ERROR", e.getMessage());
        }
    }
}
