package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field33B;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse33BField extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "33B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field33B field33B = (Field33B)tag.asField();
            Map<String, Object> instdAmtMaps = new HashMap<>();
            instdAmtMaps.put("value", field33B.amount());
            instdAmtMaps.put("ccy", field33B.getCurrency());
            cdtTrfTxInfMaps.put("instdAmt", instdAmtMaps);
        }
    }
}
