package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field54A;
import com.prowidesoftware.swift.model.field.Field54B;
import com.prowidesoftware.swift.model.field.Field54D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pacs00801Parse54Field extends AbstractMt2MxPacs008001ParseField {
    private static final String NAME_A = "54A";

    private static final String NAME_B = "54B";

    private static final String NAME_D = "54D";

    @Override
    public void parseField() throws SwiftException {
        VoSettlementMethodHelper setlMtdHelper = context.get(VoSettlementMethodHelper.class);
        if (setlMtdHelper.isTranslate54Flag()) {
            Field54A field54A = null;
            Field54B field54B = null;
            Field54D field54D = null;
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
            if (tag != null) {
                field54A = (Field54A)tag.asField();
            }
            tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_B);
            if (tag != null) {
                field54B = (Field54B)tag.asField();
            }
            tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_D);
            if (tag != null) {
                field54D = (Field54D)tag.asField();
            }
            Map<String, Object> sttlmInfMaps = null;
            if (grpHdrMaps.containsKey("sttlmInf")) {
                sttlmInfMaps = (Map<String, Object>) grpHdrMaps.get("sttlmInf");
            } else {
                sttlmInfMaps = new HashMap<>();
                grpHdrMaps.put("sttlmInf", sttlmInfMaps);
            }
            Map<String, Object> instdRmbrsmntAgtMaps = null;
            if (sttlmInfMaps.containsKey("instdRmbrsmntAgt")) {
                instdRmbrsmntAgtMaps = (Map<String, Object>) sttlmInfMaps.get("instdRmbrsmntAgt");
            } else {
                instdRmbrsmntAgtMaps = new HashMap<>();
            }
            Map<String, Object> instdRmbrsmntAgtAcctMaps = null;
            if (sttlmInfMaps.containsKey("instdRmbrsmntAgtAcct")) {
                instdRmbrsmntAgtAcctMaps = (Map<String, Object>) sttlmInfMaps.get("instdRmbrsmntAgtAcct");
            } else {
                instdRmbrsmntAgtAcctMaps = new HashMap<>();
            }
            String account = "";
            if (field54A != null) {
                String bicCode = field54A.getBIC();
                mt_to_mxBICFI(bicCode, instdRmbrsmntAgtMaps);
                if (StringUtil.isNotEmpty(field54A.getComponent1())) {
                    account = "/" + field54A.getComponent1();
                }
                if (StringUtil.isNotEmpty(field54A.getComponent2())) {
                    account = "/" + field54A.getComponent2();
                }
                if (account.startsWith("//") && !account.startsWith("//CH")) {
                    Map<String, Object> finInstnIdMaps = null;
                    if (instdRmbrsmntAgtMaps.containsKey("finInstnId")) {
                        finInstnIdMaps = (Map<String, Object>)instdRmbrsmntAgtMaps.get("finInstnId");
                    } else {
                        finInstnIdMaps = new HashMap<>();
                        instdRmbrsmntAgtMaps.put("finInstnId", finInstnIdMaps);
                    }
                    Map<String, Object> clrSysMmbIdMaps = null;
                    if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                        clrSysMmbIdMaps = (Map<String, Object>)finInstnIdMaps.get("clrSysMmbId");
                    } else {
                        clrSysMmbIdMaps = new HashMap<>();
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                    mt_to_mxFinancialInstitutionAccount(account, instdRmbrsmntAgtAcctMaps);
                }
            } else if (field54B != null) {
                if (StringUtil.isNotEmpty(field54B.getComponent1())) {
                    account = "/" + field54B.getComponent1();
                }
                if (StringUtil.isNotEmpty(field54B.getComponent2())) {
                    account = "/" + field54B.getComponent2();
                }
                String location = field54B.getLocation();
                Map<String, Object> finInstnIdMaps = null;
                if (instdRmbrsmntAgtMaps.containsKey("finInstnId")) {
                    finInstnIdMaps = (Map<String, Object>)instdRmbrsmntAgtMaps.get("finInstnId");
                } else {
                    finInstnIdMaps = new HashMap<>();
                    instdRmbrsmntAgtMaps.put("finInstnId", finInstnIdMaps);
                }
                if (account.startsWith("//") && !account.startsWith("//CH")) {
                    if (isMTClearingSystemCodeInList(account)) {
                        Map<String, Object> clrSysMmbIdMaps = null;
                        if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                            clrSysMmbIdMaps = (Map<String, Object>)finInstnIdMaps.get("clrSysMmbId");
                        } else {
                            clrSysMmbIdMaps = new HashMap<>();
                            finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                        }
                        mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                        //name address 设置NOTPROVIDED
                        finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                        Map<String, Object> pstlAdrMaps = null;
                        if (finInstnIdMaps.containsKey("pstlAdr")) {
                            pstlAdrMaps = (Map<String, Object>)finInstnIdMaps.get("pstlAdr");
                        } else {
                            pstlAdrMaps = new HashMap<>();
                            finInstnIdMaps.put("pstlAdr", pstlAdrMaps);
                        }
                        List<String> adrLineList = new ArrayList<>();
                        adrLineList.add(StringUtil.isEmpty(location)?Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE:location);
                        pstlAdrMaps.put("adrLine", adrLineList);
                    } else {
                        mt_to_mxClearingSystemToNameAndAddressLine(account, location, finInstnIdMaps);
                    }
                } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                    mt_to_mxFinancialInstitutionAccount(account, instdRmbrsmntAgtAcctMaps);
                    //name address 设置NOTPROVIDED
                    finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                    Map<String, Object> pstlAdrMaps = null;
                    if (finInstnIdMaps.containsKey("pstlAdr")) {
                        pstlAdrMaps = (Map<String, Object>)finInstnIdMaps.get("pstlAdr");
                    } else {
                        pstlAdrMaps = new HashMap<>();
                        finInstnIdMaps.put("pstlAdr", pstlAdrMaps);
                    }
                    List<String> adrLineList = new ArrayList<>();
                    adrLineList.add(StringUtil.isEmpty(location)?Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE:location);
                    pstlAdrMaps.put("adrLine", adrLineList);
                }
            } else if (field54D != null) {
                if (StringUtil.isNotEmpty(field54D.getComponent1())) {
                    account = "/" + field54D.getComponent1();
                }
                if (StringUtil.isNotEmpty(field54D.getComponent2())) {
                    account = "/" + field54D.getComponent2();
                }
                String nameAddress = field54D.getNameAndAddress();
                mt_to_mxFinancialInstitutionNameAndUnstructuredAddress(nameAddress, instdRmbrsmntAgtMaps);
                if (account.startsWith("//") && !account.startsWith("//CH")) {
                    Map<String, Object> finInstnIdMaps = null;
                    if (instdRmbrsmntAgtMaps.containsKey("finInstnId")) {
                        finInstnIdMaps = (Map<String, Object>)instdRmbrsmntAgtMaps.get("finInstnId");
                    } else {
                        finInstnIdMaps = new HashMap<>();
                        instdRmbrsmntAgtMaps.put("finInstnId", finInstnIdMaps);
                    }
                    Map<String, Object> clrSysMmbIdMaps = null;
                    if (finInstnIdMaps.containsKey("clrSysMmbId")) {
                        clrSysMmbIdMaps = (Map<String, Object>)finInstnIdMaps.get("clrSysMmbId");
                    } else {
                        clrSysMmbIdMaps = new HashMap<>();
                        finInstnIdMaps.put("clrSysMmbId", clrSysMmbIdMaps);
                    }
                    mt_to_mxClearingIdentifier(account, clrSysMmbIdMaps);
                } else if (!account.startsWith("//") || account.startsWith("//CH")) {
                    mt_to_mxFinancialInstitutionAccount(account, instdRmbrsmntAgtAcctMaps);
                }
            }
            if (instdRmbrsmntAgtMaps.size() > 0) {
                sttlmInfMaps.put("instdRmbrsmntAgt", instdRmbrsmntAgtMaps);
            }
            if (instdRmbrsmntAgtAcctMaps.size() > 0) {
                sttlmInfMaps.put("instdRmbrsmntAgtAcct", instdRmbrsmntAgtAcctMaps);
            }
        }
    }
}
