package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field59;
import com.prowidesoftware.swift.model.field.Field59A;
import com.prowidesoftware.swift.model.field.Field59F;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pacs00801Parse59Field extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "59";

    private static final String NAME_A = "59A";

    private static final String NAME_F = "59F";

    @Override
    public void parseField() throws SwiftException {
        Field59 field59 = null;
        Field59A field59A = null;
        Field59F field59F = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            field59 = (Field59)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field59A = (Field59A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_F);
        if (tag != null) {
            field59F = (Field59F)tag.asField();
        }
        Map<String, Object> cdtrMaps = null;
        if (cdtTrfTxInfMaps.containsKey("cdtr")) {
            cdtrMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("cdtr");
        } else {
            cdtrMaps = new HashMap<>();
        }
        Map<String, Object> cdtrAcctMaps = null;
        if (cdtTrfTxInfMaps.containsKey("cdtrAcct")) {
            cdtrAcctMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("cdtrAcct");
        } else {
            cdtrAcctMaps = new HashMap<>();
        }
        String account = "";
        if (field59A != null) {
            String bicCode = field59A.getBIC();
            if (StringUtil.isNotEmpty(field59A.getComponent1())) {
                account += "/" + field59A.getComponent1();
            }
            mt_to_mxAnyBIC(bicCode, cdtrMaps);
            if (StringUtil.isEmpty(account)) {
                buildDefaultValue(cdtrMaps);
            } else {
                mt_to_mxPartyAccount(account, cdtrAcctMaps);
            }
        }
        if (field59F != null) {
            if (StringUtil.isNotEmpty(field59F.getComponent1())) {
                account += "/" + field59F.getComponent1();
            }
            if (StringUtil.isEmpty(account)) {
                buildDefaultValue(cdtrMaps);
            } else {
                mt_to_mxPartyAccount(account, cdtrAcctMaps);
            }
            String nameAddress = "";
            List<String> lines = field59F.getLines();
            for (int i=0; i<lines.size(); i++) {
                if (i == 0 && StringUtil.isNotEmpty(account)) {
                    continue;
                }
                if (i == lines.size()-1) {
                    nameAddress += lines.get(i);
                } else {
                    nameAddress += lines.get(i) + Mx2MtConstants.NEW_LINE;
                }
            }
            mt_to_mxPartyNameAndStructuredAddress(nameAddress, cdtrMaps);
        }
        if (field59 != null) {
            String nameAddress = field59.getNameAndAddress(Mx2MtConstants.NEW_LINE);
            if (StringUtil.isNotEmpty(field59.getComponent1())) {
                account += "/" + field59.getComponent1();
            }
            mt_to_mxPartyNameAndAddress(nameAddress, cdtrMaps);
            if (StringUtil.isEmpty(account)) {
                buildDefaultValue(cdtrMaps);
            } else {
                mt_to_mxPartyAccount(account, cdtrAcctMaps);
            }
        }
        if (cdtrMaps.size() > 0) {
            cdtTrfTxInfMaps.put("cdtr", cdtrMaps);
        }
        if (cdtrAcctMaps.size() > 0) {
            cdtTrfTxInfMaps.put("cdtrAcct", cdtrAcctMaps);
        }
    }
    /**
     * IF 59A/Account 59/Account IsAbsent
     * THEN Copy "NOTPROVIDED" to Debtor/Id/OrgID/Other/ID
     * and "TXID" to SchemeName/Code
     * @param dbtrMaps
     */
    private void buildDefaultValue(Map<String, Object> dbtrMaps) {
        Map<String, Object> idMaps = null;
        if (dbtrMaps.containsKey("id")) {
            idMaps = (Map<String, Object>)dbtrMaps.get("id");
        } else {
            idMaps = new HashMap<>();
            dbtrMaps.put("id", idMaps);
        }
        Map<String, Object> idOrgMaps = null;
        if (idMaps.containsKey("orgId")) {
            idOrgMaps = (Map<String, Object>)idMaps.get("orgId");
        } else {
            idOrgMaps = new HashMap<>();
            idMaps.put("orgId", idOrgMaps);
        }
        JSONArray othrJsonArray = null;
        if (idOrgMaps.containsKey("othr")) {
            othrJsonArray = (JSONArray) idOrgMaps.get("othr");
        } else {
            othrJsonArray = new JSONArray();
            idOrgMaps.put("othr", othrJsonArray);
        }
        Map<String, Object> othrMaps = new HashMap<>();
        othrJsonArray.add(othrMaps);
        othrMaps.put("id", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
    }
}
