package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field70;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Pacs00801Parse70Field extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "70";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field70 field70 = (Field70)tag.asField();
            String mt70 = field70.getValue();
            String endToEndId = mt70roc_to_mx35Text(mt70);;
            if (StringUtil.isEmpty(endToEndId)) {
                endToEndId = Mx2MtConstants.MX_END_TO_END_ID_DEFAULT_VALUE;
            }
            Map<String, Object> pmtIdMaps = null;
            if (cdtTrfTxInfMaps.containsKey("pmtId")) {
                pmtIdMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("pmtId");
            } else {
                pmtIdMaps = new HashMap<>();
                cdtTrfTxInfMaps.put("pmtId", pmtIdMaps);
            }
            pmtIdMaps.put("endToEndId", endToEndId);
            Map<String, Object> rmtInfMaps = null;
            if (cdtTrfTxInfMaps.containsKey("rmtInf")) {
                rmtInfMaps = (Map<String, Object>) cdtTrfTxInfMaps.get("rmtInf");
            } else {
                rmtInfMaps = new HashMap<>();
            }
            mt_to_mxRemittanceInformation(mt70, rmtInfMaps);
            if (rmtInfMaps.size() > 0) {
                cdtTrfTxInfMaps.put("rmtInf", rmtInfMaps);
            }
        }
    }
}
