package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.common.ChargeForEnum;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field71A;
import com.prowidesoftware.swift.model.field.Field71F;
import com.prowidesoftware.swift.model.field.Field71G;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pacs00801Parse71Field extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME_A = "71A";

    private static final String NAME_F = "71F";

    private static final String NAME_G = "71G";

    @Override
    public void parseField() throws SwiftException {
        Field71A field71A = null;
        Field71G field71G = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_A);
        if (tag != null) {
            field71A = (Field71A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME_G);
        if (tag != null) {
            field71G = (Field71G)tag.asField();
        }
        if (field71A != null) {
            ChargeForEnum chargeForEnum = SwiftTransferUtil.getChargeForByDesc(field71A.getValue());
            if (chargeForEnum != null) {
                cdtTrfTxInfMaps.put("chrgBr", chargeForEnum.value());
            }
        }
        if (field71G != null) {
            String ccy = field71G.getCurrency();
            BigDecimal amt = field71G.amount();
            JSONArray jsonArray = new JSONArray();
            cdtTrfTxInfMaps.put("chrgsInf", jsonArray);
            Map<String, Object> chrgsInfMaps = new HashMap<>();
            jsonArray.add(chrgsInfMaps);
            Map<String, Object> amtMaps = new HashMap<>();
            amtMaps.put("value", amt);
            amtMaps.put("ccy", ccy);
            chrgsInfMaps.put("amt", amtMaps);

            Map<String, Object> agtMaps = new HashMap<>();
            chrgsInfMaps.put("agt", agtMaps);
            String receiverBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
            mt_to_mxBICFI(receiverBic, agtMaps);
        }
        Tag[] tags = abstractMT.getSwiftMessage().getBlock4().getTagsByName(NAME_F);
        if (tag != null && tags.length > 0) {
            JSONArray jsonArray = new JSONArray();
            cdtTrfTxInfMaps.put("chrgsInf", jsonArray);
            for (int i=0; i<tags.length; i++) {
                Field71F field71F = (Field71F)tags[i].asField();
                String ccy = field71F.getCurrency();
                BigDecimal amt = field71F.amount();
                Map<String, Object> chrgsInfMaps = new HashMap<>();
                jsonArray.add(chrgsInfMaps);
                Map<String, Object> amtMaps = new HashMap<>();
                amtMaps.put("value", amt);
                amtMaps.put("ccy", ccy);
                chrgsInfMaps.put("amt", amtMaps);

                Map<String, Object> agtMaps = new HashMap<>();
                chrgsInfMaps.put("agt", agtMaps);
                Map<String, Object> finInstnIdMaps = null;
                if (agtMaps.containsKey("finInstnId")) {
                    finInstnIdMaps = (Map<String, Object>)agtMaps.get("finInstnId");
                } else {
                    finInstnIdMaps = new HashMap<>();
                    agtMaps.put("finInstnId", finInstnIdMaps);
                }
                //name address 设置NOTPROVIDED
                finInstnIdMaps.put("nm", Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                Map<String, Object> pstlAdrMaps = null;
                if (finInstnIdMaps.containsKey("pstlAdr")) {
                    pstlAdrMaps = (Map<String, Object>)finInstnIdMaps.get("pstlAdr");
                } else {
                    pstlAdrMaps = new HashMap<>();
                    finInstnIdMaps.put("pstlAdr", pstlAdrMaps);
                }
                List<String> adrLineList = new ArrayList<>();
                adrLineList.add(Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE);
                pstlAdrMaps.put("adrLine", adrLineList);
            }
        }
    }
}
