package com.brilliance.swift.mt2mx.pacs008001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs008001.AbstractMt2MxPacs008001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.List;

public class Pacs00801Parse72Field extends AbstractMt2MxPacs008001ParseField {

    private static final String NAME = "72";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag != null) {
            Field72 field72 = (Field72)tag.asField();
            mt72ins_to_mxAgent(field72.getValue(), cdtTrfTxInfMaps);
            List<String> excludeCodeList = new ArrayList<>();
            excludeCodeList.add("/ACC/");
            excludeCodeList.add("/INS/");
            excludeCodeList.add("/INTA/");
            excludeCodeList.add("/SVCLVL/");
            excludeCodeList.add("/LOCINS/");
            excludeCodeList.add("/CATPURP/");
            mt72_to_mxNextAgent(field72.getValue(), excludeCodeList, cdtTrfTxInfMaps);
            mt_to_mxField72NewCodeWords(field72.getValue(), false, cdtTrfTxInfMaps);
        }
    }
}
