package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.List;

public class Pacs009001Parse72Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "72";

    private static final String SEQUENCE_A = "A";

    @Override
    public void parseField() throws SwiftException {
        Tag tag = getTagByName(NAME, SEQUENCE_A);
        if (tag != null) {
            Field72 field72 = (Field72)tag.asField();
            mt_to_mxInstructionForCreditorAgent2(field72.getValue(), cdtTrfTxInfMaps);
            mt72ins_to_mxAgent(field72.getValue(), cdtTrfTxInfMaps);
            mt_to_mxBNF_TSU_RI(field72.getValue(), cdtTrfTxInfMaps);
            List<String> excludeCodeList = new ArrayList<>();
            excludeCodeList.add("/ACC/");
            excludeCodeList.add("/UDLC/");
            excludeCodeList.add("/INS/");
            excludeCodeList.add("/BNF/");
            excludeCodeList.add("/TSU/");
            excludeCodeList.add("/PHONBEN/");
            excludeCodeList.add("/TELEBEN/");
            excludeCodeList.add("/INTA/");
            excludeCodeList.add("/SVCLVL/");
            excludeCodeList.add("/LOCINS/");
            excludeCodeList.add("/CATPURP/");
            excludeCodeList.add("/PURP/");
            mt72_to_mxNextAgent(field72.getValue(), excludeCodeList, cdtTrfTxInfMaps);
            mt_to_mxField72NewCodeWords(field72.getValue(), true, cdtTrfTxInfMaps);
        }
    }
}
