package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field72;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.List;

public class Pacs009001ParseSeqB72Field extends AbstractMt2MxPacs009001ParseField {

    private static final String NAME = "72";

    private static final String SEQUENCE_B = "B";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        if (!abstractMT.getSwiftMessage().isCOV()) {
            return;
        }
        Tag tag = getTagByName(NAME, SEQUENCE_B);
        if (tag != null) {
            Field72 field72 = (Field72)tag.asField();
            mt72ins_to_mxAgent(field72.getValue(), undrlygCstmrCdtTrfMaps);
            List<String> excludeCodeList = new ArrayList<>();
            excludeCodeList.add("/ACC/");
            excludeCodeList.add("/INS/");
            excludeCodeList.add("/INTA/");
            mt72_to_mxNextAgent(field72.getValue(), excludeCodeList, undrlygCstmrCdtTrfMaps);
            mt_to_mxField72NewCodeWords(field72.getValue(), false, undrlygCstmrCdtTrfMaps);
        }
    }
}
