package com.brilliance.swift.mt2mx.pacs009001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.pacs009001.AbstractMt2MxPacs009001ParseField;
import com.brilliance.swift.mt2mx.setlmtd.SettlementMethodAnalyzerFactory;
import com.brilliance.swift.vo.VoSettlementMethodHelper;

import java.util.HashMap;
import java.util.Map;

/**
 * Group Header -> Settlement Information -> Settlement Method
 */
public class Pacs009001ParseSetlMtdField extends AbstractMt2MxPacs009001ParseField {
    @Override
    public void parseField() throws SwiftException {
        VoSettlementMethodHelper setlMtdHelper = SettlementMethodAnalyzerFactory.find(context).analyse();
        String settlementMethod = setlMtdHelper.getSettlementMethod();
        Map<String, Object> sttlmInfMaps = null;
        if (grpHdrMaps.containsKey("sttlmInf")) {
            sttlmInfMaps = (Map<String, Object>) grpHdrMaps.get("sttlmInf");
        } else {
            sttlmInfMaps = new HashMap<>();
            grpHdrMaps.put("sttlmInf", sttlmInfMaps);
        }
        sttlmInfMaps.put("sttlmMtd", settlementMethod);
        context.set(setlMtdHelper);
    }
}
