package com.brilliance.swift.mt2mx.setlmtd;

import com.brilliance.swift.mt2mx.Mt2MxContext;
import com.brilliance.swift.mt2mx.setlmtd.impl.*;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.*;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class SettlementMethodAnalyzerFactory {

    public static SettlementMethodAnalyzer find(Mt2MxContext context) {
        SettlementMethodAnalyzer analyzer = null;
        Field53A field53A = null;
        Field53B field53B = null;
        Field53D field53D = null;
        Field54A field54A = null;
        Field54B field54B = null;
        Field54D field54D = null;
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("53A");
        if (tag != null) {
            field53A = (Field53A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("53B");
        if (tag != null) {
            field53B = (Field53B)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("53D");
        if (tag != null) {
            field53D = (Field53D)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("54A");
        if (tag != null) {
            field54A = (Field54A)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("54B");
        if (tag != null) {
            field54B = (Field54B)tag.asField();
        }
        tag = abstractMT.getSwiftMessage().getBlock4().getTagByName("54D");
        if (tag != null) {
            field54D = (Field54D)tag.asField();
        }
        boolean noneField53 = false;
        if (field53A == null && field53B == null && field53D == null) {
            noneField53 = true;
        }
        boolean noneField54 = false;
        if (field54A == null && field54B == null && field54D == null) {
            noneField54 = true;
        }
        if (noneField53 && noneField54) {
            analyzer = new FieldNone5354Analyzer().setContext(context);
        } else if (field53A != null && noneField54) {
            analyzer = new FieldOnly53AAnalyzer()
                        .setContext(context)
                        .setField53(field53A);
        } else if (field53B != null && noneField54) {
            analyzer = new FieldOnly53BAnalyzer()
                        .setContext(context)
                        .setField53(field53B);
        } else if (field53D != null && noneField54) {
            analyzer = new FieldOnly53DAnalyzer()
                        .setContext(context)
                        .setField53(field53D);
        } else if (noneField53 && field54A != null) {
            analyzer = new FieldOnly54AAnalyzer()
                        .setContext(context)
                        .setField54(field54A);
        } else if (noneField53 && field54B != null) {
            analyzer = new FieldOnly54BAnalyzer()
                        .setContext(context)
                        .setField54(field54B);
        } else if (noneField53 && field54D != null) {
            analyzer = new FieldOnly54DAnalyzer()
                        .setContext(context)
                        .setField54(field54D);
        } else if (field53A != null && field54A != null) {
            analyzer = new Field53A54AAnalyzer()
                        .setContext(context)
                        .setField53(field53A)
                        .setField54(field54A);
        } else if (field53A != null && field54B != null) {
            analyzer = new Field53A54BAnalyzer()
                        .setContext(context)
                        .setField53(field53A)
                        .setField54(field54B);
        } else if (field53A != null && field54D != null) {
            analyzer = new Field53A54DAnalyzer()
                        .setContext(context)
                        .setField53(field53A)
                        .setField54(field54D);
        } else if (field53B != null && field54A != null) {
            analyzer = new Field53B54aAnalyzer()
                        .setContext(context)
                        .setField53(field53B)
                        .setField54(field54A);
        } else if (field53B != null && !noneField54) {
            analyzer = new Field53B54aAnalyzer()
                        .setContext(context)
                        .setField53(field53B);
        } else if (field53D != null && !noneField54) {
            analyzer = new Field53D54aAnalyzer()
                        .setContext(context)
                        .setField53(field53D);
        }
        return analyzer;
    }
}
