package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field53A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class Field53A54BAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field53A field53A = (Field53A)field53;
        String field53BicCode = field53A.getBIC();
        String account = "";
        if (StringUtil.isNotEmpty(field53A.getComponent1())) {
            account += "/" + field53A.getComponent1();
        }
        if (StringUtil.isNotEmpty(field53A.getComponent2())) {
            account += "/" + field53A.getComponent2();
        }
        String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
        if (StringUtil.isNotEmpty(sendBic)
                && field53BicCode.substring(0, 6).equals(sendBic.substring(0, 6))
                && SwiftTransferUtil.isAccount(account)) {
            if (account.startsWith("/C/")) {
                seltMtdHelper.setSettlementMethod("INGA");
            } else {
                seltMtdHelper.setSettlementMethod("INDA");
            }
            seltMtdHelper.setTranslateSetlAcctFlag(true);
        } else {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            if (abstractMT.getSwiftMessage().isCOV()) {
                seltMtdHelper.setSettlementMethod("INDA");
            } else {
                seltMtdHelper.setSettlementMethod("COVE");
                seltMtdHelper.setTranslate53Flag(true);
                seltMtdHelper.setTranslate54Flag(true);
                seltMtdHelper.setTranslate55Flag(true);
            }
        }
        return seltMtdHelper;
    }
}
