package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field53B;

public class Field53B54aAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field53B field53B = (Field53B)field53;
        String account = "";
        if (StringUtil.isNotEmpty(field53B.getComponent1())) {
            account += "/" + field53B.getComponent1();
        }
        if (StringUtil.isNotEmpty(field53B.getComponent2())) {
            account += "/" + field53B.getComponent2();
        }
        if (SwiftTransferUtil.isAccount(account)) {
            if (account.startsWith("/C/")) {
                seltMtdHelper.setSettlementMethod("INGA");
            } else {
                seltMtdHelper.setSettlementMethod("INDA");
            }
            seltMtdHelper.setTranslateSetlAcctFlag(true);
        } else {
            seltMtdHelper.setSettlementMethod("INDA");
        }
        return seltMtdHelper;
    }
}
