package com.brilliance.swift.mt2mx.setlmtd.impl;

import com.brilliance.swift.mt2mx.Mt2MxContextIdentifier;
import com.brilliance.swift.mt2mx.setlmtd.AbstractSettlementMethodAnalyzer;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.util.SwiftTransferUtil;
import com.brilliance.swift.vo.VoSettlementMethodHelper;
import com.prowidesoftware.swift.model.field.Field53A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

public class FieldOnly53AAnalyzer extends AbstractSettlementMethodAnalyzer {
    @Override
    public VoSettlementMethodHelper analyse() {
        VoSettlementMethodHelper seltMtdHelper = new VoSettlementMethodHelper();
        Field53A field53A = (Field53A) field53;
        String account = "";
        if (StringUtil.isNotEmpty(field53A.getComponent1())) {
            account += "/" + field53A.getComponent1();
        }
        if (StringUtil.isNotEmpty(field53A.getComponent2())) {
            account += "/" + field53A.getComponent2();
        }
        String bicCode = field53A.getBIC();
        if (SwiftTransferUtil.isAccount(account)) {
            if (account.startsWith("/C/")) {
                seltMtdHelper.setSettlementMethod("INGA");
            } else {
                seltMtdHelper.setSettlementMethod("INDA");
            }
            seltMtdHelper.setTranslateSetlAcctFlag(true);
            seltMtdHelper.setInstructionForNextAgent("/FIN53/"+bicCode);
        } else {
            String sendBic = (String) context.get(Mt2MxContextIdentifier.MT_SEND_BIC, true);
            String receiveBic = (String) context.get(Mt2MxContextIdentifier.MT_RECEIVE_BIC, true);
            if ((StringUtil.isNotEmpty(sendBic) && bicCode.substring(0, 6).equals(sendBic.substring(0, 6)))
                || (StringUtil.isNotEmpty(receiveBic) && bicCode.substring(0, 6).equals(receiveBic.substring(0, 6)))) {
                seltMtdHelper.setSettlementMethod("INDA");
                seltMtdHelper.setInstructionForNextAgent("/FIN53/"+bicCode);
            } else {
                AbstractMT abstractMT = context.get(AbstractMT.class);
                if (abstractMT.getSwiftMessage().isCOV()) {
                    seltMtdHelper.setSettlementMethod("INDA");
                } else {
                    seltMtdHelper.setSettlementMethod("COVE");
                    seltMtdHelper.setTranslate53Flag(true);
                }
            }
        }
        return seltMtdHelper;
    }
}
