package com.brilliance.swift.mx2map;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2map.camt053.Mx2MapCamt053Creator;
import com.prowidesoftware.swift.model.mx.AbstractMX;

import java.util.Map;

public class Mx2MapCreatorManager {

    public Map<String, String> mx2Map(String xml) throws SwiftException {
        AbstractMX abstractMX = AbstractMX.parse(xml);
        String messageType = (abstractMX.getMxId().getBusinessProcess().name()
                + "."
                + abstractMX.getMxId().getFunctionality()
                + "."
                + abstractMX.getMxId().getVariant())
                //+ abstractMX.getMxId().getVersion())
                .trim();
        AbstractMx2MapCreator creator = getCreator(messageType);
        creator.setXmlStr(xml);
        creator.setAbstractMX(abstractMX);
        return creator.mx2Map();
    }

    public AbstractMx2MapCreator getCreator(String messageType) {
        if("camt.053.001".equals(messageType)){
            return new Mx2MapCamt053Creator();
        } else {
            return new DefaultMx2MapCreator();
        }
    }
}
