package com.brilliance.swift.mx2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.common.CategoryPurposeCode;
import com.brilliance.swift.vo.common.ServiceLevelCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

/**
 *
 */
public class Field23EGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "23E";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        //CdtTrfTxInf.PmtTpInf.SvcLvl
        int svcLvlCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.PmtTpInf.SvcLvl");
        if (svcLvlCount > 0) {
            for (int i=0; i<svcLvlCount; i++) {
                String code = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.PmtTpInf.SvcLvl("+i+").Cd");
                if (ServiceLevelCode.SDVA.value().equals(code)) {
                    tags.add(new Tag(name, code));
                    break;
                }
            }
        }
        //CdtTrfTxInf.PmtTpInf.CtgyPurp.Cd
        String ctgyPurpCode = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.PmtTpInf.CtgyPurp.Cd");
        String ctgyPurpProprietary = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.PmtTpInf.CtgyPurp.Prtry");
        if (CategoryPurposeCode.INTC.value().equals(ctgyPurpCode) || CategoryPurposeCode.CORT.value().equals(ctgyPurpCode)) {
            tags.add(new Tag(name, ctgyPurpCode));
        } else {
            String proprietary = CategoryPurposeCode.INTC.value() + " " + CategoryPurposeCode.CORT.value();
            if (proprietary.equalsIgnoreCase(ctgyPurpProprietary)) {
                tags.add(new Tag(name, CategoryPurposeCode.INTC.value()));
                tags.add(new Tag(name, CategoryPurposeCode.CORT.value()));
            }
        }
        //CdtTrfTxInf.InstrForCdtrAgt
        int instrForCdtrAgtCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.InstrForCdtrAgt");
        if (instrForCdtrAgtCount > 0) {
            List<String> list = new ArrayList<>();
            String totalInstrInf = "";
            for (int i=0; i<instrForCdtrAgtCount; i++) {
                if (i == 2) break;//只取2个CdtrAgt
                String code = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.InstrForCdtrAgt("+i+").Cd");
                String instrInf = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.InstrForCdtrAgt("+i+").InstrInf");
                if (StringUtil.isNotEmpty(code)) {
                    list.addAll(mx_to_mt23E(code, instrInf));
                } else {
                    totalInstrInf += instrInf;
                }
            }
            if (totalInstrInf.length() > 0) {
                list.addAll(mx_to_mt23E_BIS(totalInstrInf));
            }
            if (list.size() > 0) {
                for (String value : list) {
                    tags.add(new Tag(name, value));
                }
            }
        }

    }
}
