package com.brilliance.swift.mx2mt.mt103Retn.impl;


import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

public class Field13CGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "13C";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String dbtDtTmStr = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.SttlmTmIndctn.DbtDtTm");
            if (StringUtil.isNotEmpty(dbtDtTmStr)) {
                XMLGregorianCalendar dbtDtTm = DatatypeFactory.newInstance().newXMLGregorianCalendar(dbtDtTmStr);
                String timeOff = dbtDtTmStr.substring(dbtDtTmStr.length()-6);
                String[] timeOffs = timeOff.split(":");
                if (timeOffs.length == 2) {
                    String value = "/SNDTIME/" + (dbtDtTm.getHour()<10?"0"+dbtDtTm.getHour():dbtDtTm.getHour()) + (dbtDtTm.getMinute()<10?"0"+dbtDtTm.getMinute():dbtDtTm.getMinute()) + timeOffs[0] + timeOffs[1];
                    tags.add(new Tag(name, value));
                }
            }
            String cdtDtTmStr = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.SttlmTmIndctn.CdtDtTm");
            if (StringUtil.isNotEmpty(cdtDtTmStr)) {
                XMLGregorianCalendar cdtDtTm = DatatypeFactory.newInstance().newXMLGregorianCalendar(cdtDtTmStr);
                String timeOff = cdtDtTmStr.substring(cdtDtTmStr.length()-6);
                String[] timeOffs = timeOff.split(":");
                if (timeOffs.length == 2) {
                    String value = "/RNCTIME/" + (cdtDtTm.getHour()<10?"0"+cdtDtTm.getHour():cdtDtTm.getHour()) + (cdtDtTm.getMinute()<10?"0"+cdtDtTm.getMinute():cdtDtTm.getMinute()) + timeOffs[0] + timeOffs[1];
                    tags.add(new Tag(name, value));
                }
            }
        } catch(DatatypeConfigurationException e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
