package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field25Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "25";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String account = "";
        String iban = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Acct.Id.IBAN");
        String id = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Acct.Id.Othr.Id");
        if(StringUtil.isNotEmpty(iban)){
            account = iban;
        }else if(StringUtil.isNotEmpty(id)){
            account = id;
        }else if(StringUtil.isEmpty(iban)&&StringUtil.isEmpty(id)){
            String itemIban = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Acct.Id.IBAN");
            String itemId = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Acct.Id.Othr.Id");
            if(StringUtil.isNotEmpty(itemIban)){
                account = itemIban;
            }else if(StringUtil.isNotEmpty(itemId)){
                account = itemId;
            }
        }
        if(account.length()>0){
            tags.add(new Tag(name, account));
        }

    }
}
