package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field32BGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "32B";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String amt = "";
        String ccy = "";
        String amtStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Amt");
        String ccyStr = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Amt@Ccy");
        if (StringUtil.isNotEmpty(amtStr)&&StringUtil.isNotEmpty(ccyStr)) {
            amt = NumberUtil.formatAmt(new BigDecimal(amtStr), ccyStr);
            ccy = ccyStr;
            tags.add(new Tag(name, ccy+amt));
        }
    }
}
