package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field50aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_ = "50";

    private static String name_C = "50C";

    private static String name_F = "50F";


    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int counts1 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Pty");
        int counts2 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Pty");
        int counts3 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Agt");
        int counts4 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Agt");
        if(counts1>0||counts2>0||counts3>0||counts4>0){
            context.set(Mx2MtContextIdentifier.MT_TYPE_210_50_FLAG, Mx2MtConstants.YES);
        }
        String partyPath = "";
        String bicCode = "";
        String country = "";
        int addressLineCount = 0;
        String name = "";
        String clearSystemId = "";
        if(counts1>0){
            partyPath = bodyHdrParentElementName + ".Ntfctn.Dbtr.Pty";
            bicCode = mx_to_mtAnyBIC(bodyHdrParentElementName + ".Ntfctn.Dbtr.Pty");
            country = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Pty.PstlAdr.Ctry");
            addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Pty.PstlAdr.AdrLine");
            name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Pty.Nm");
        }
        if(counts2>0){
            partyPath = bodyHdrParentElementName + ".Ntfctn.Itm.Dbtr.Pty";
            bicCode = mx_to_mtAnyBIC(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").Dbtr.Pty");
            country = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Pty.PstlAdr.Ctry");
            addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Pty.PstlAdr.AdrLine");
            name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Pty.Nm");
        }
        if(counts3>0){
            partyPath = bodyHdrParentElementName + ".Ntfctn.Dbtr.Agt";
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName+".Ntfctn.Dbtr.Agt");
            country = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Agt.FinInstnId.PstlAdr.Ctry");
            addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Agt.FinInstnId.PstlAdr.AdrLine");
            name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Dbtr.Agt.FinInstnId.Nm");
            clearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.Dbtr.Agt");
        }
        if(counts4>0){
            partyPath = bodyHdrParentElementName + ".Ntfctn.Itm("+0+").Dbtr.Agt";
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName+".Ntfctn.Itm("+0+").Dbtr.Agt");
            country = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Agt.FinInstnId.PstlAdr.Ctry");
            addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Agt.FinInstnId.PstlAdr.AdrLine");
            name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").Dbtr.Agt.FinInstnId.Nm");
            clearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").Dbtr.Agt");
        }
        if(counts1>0||counts2>0){
            String account = mx_to_mtFATFIdentification(partyPath);
            if (StringUtil.isNotEmpty(account) && account.length() > 35) {
                account = account.substring(0, 35);
            }
            if (StringUtil.isEmpty(account)) {
                account = "/" + Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            if(StringUtil.isNotEmpty(bicCode)){
                tags.add(new Tag(name_C, bicCode));
            }else if(StringUtil.isNotEmpty(country)){
                String nameAddress = mx_to_mtFATFNameAndAddress(partyPath);
                tags.add(new Tag(name_F, account + Mx2MtConstants.NEW_LINE + nameAddress));
            }else if(addressLineCount>0){
                boolean structuredAddressIndicator = mx_to_mtAddressLineType(partyPath);
                if (structuredAddressIndicator) {
                    String nameAddress = mx_to_mtFATFNameAndAddress2(partyPath);
                    tags.add(new Tag(name_F, account + Mx2MtConstants.NEW_LINE + nameAddress));
                } else {
                    String mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(partyPath);
                    tags.add(new Tag(name_, mtNameAddress));
                }
            }else if(StringUtil.isNotEmpty(name)){
                String mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(partyPath);
                tags.add(new Tag(name_F, account + Mx2MtConstants.NEW_LINE + mtNameAddress));
            }
        }
        if(counts3>0||counts4>0) {
            if (StringUtil.isNotEmpty(bicCode)) {
                tags.add(new Tag(name_C, bicCode));
            } else if (StringUtil.isNotEmpty(country)) {
                String nameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName + ".Ntfctn.Dbtr.Agt.FinInstnId", false);
                tags.add(new Tag(name_F, nameAddress));
            } else if (addressLineCount > 0) {
                String nameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(partyPath);
                tags.add(new Tag(name_, nameAddress));
            } else if (StringUtil.isNotEmpty(clearSystemId)) {
                tags.add(new Tag(name_, clearSystemId));
            }
        }
    }
}
