package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field52aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "52A";

    private static String name_D = "52D";

    @Override
    public void tagGenerate() throws SwiftException {
        String s = (String)context.get(Mx2MtContextIdentifier.MT_TYPE_210_50_FLAG);
        if(Mx2MtConstants.YES.equals(s)){
            return;
        }
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int counts1 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.DbtrAgt");
        int counts2 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").DbtrAgt");
        String bicCode = "";
        String account = "";
        String mtClearSystemId = "";
        if(counts1>0){
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName + ".Ntfctn.DbtrAgt");
            account = mx_to_mtAccount(bodyHdrParentElementName + ".Ntfctn.DbtrAgt");
            mtClearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.DbtrAgt");
        }
        if(counts2>0){
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").DbtrAgt");
            account = mx_to_mtAccount(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").DbtrAgt");
            mtClearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").DbtrAgt");
        }
        String mtAccount = "";
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(account)) {
                mtAccount = account;
            } else {
                mtAccount = mtClearSystemId;
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else {
            String name = "";
            String countryCode = "";
            int addressLineCount = 0;
            String mtNameAddress = "";
            if(counts1>0){
                name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.DbtrAgt.FinInstnId.Nm");
                countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.DbtrAgt.FinInstnId.PstlAdr.Ctry");
                addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.DbtrAgt.FinInstnId.PstlAdr.AdrLine");
                if (addressLineCount > 0) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.DbtrAgt.FinInstnId");
                } else if (StringUtil.isNotEmpty(countryCode)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".Ntfctn.DbtrAgt.FinInstnId", false);
                } else if (StringUtil.isNotEmpty(name)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.DbtrAgt.FinInstnId");
                }
            }
            if(counts2>0){
                name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").DbtrAgt.FinInstnId.Nm");
                countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").DbtrAgt.FinInstnId.PstlAdr.Ctry");
                addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").DbtrAgt.FinInstnId.PstlAdr.AdrLine");
                if (addressLineCount > 0) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.Itm("+0+").DbtrAgt.FinInstnId");
                } else if (StringUtil.isNotEmpty(countryCode)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".Ntfctn.Itm("+0+").DbtrAgt.FinInstnId", false);
                } else if (StringUtil.isNotEmpty(name)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".NtfctnItm("+0+")..DbtrAgt.FinInstnId");
                }
            }
            if (StringUtil.isEmpty(mtNameAddress)) return;//如果name和地址不存在，返回。
            if (StringUtil.isNotEmpty(mtClearSystemId)) {
                mtAccount = mtClearSystemId;
            } else {
                mtAccount = account;
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            tags.add(new Tag(name_D, value));
        }
    }
}
