package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field56aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "56A";

    private static String name_D = "56D";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int counts1 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.IntrmyAgt");
        int counts2 = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").IntrmyAgt");
        String bicCode ="";
        String mtClearSystemId = "";
        String mtClearChannelId = "";
        if(counts1>0){
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName + ".Ntfctn.IntrmyAgt");
            mtClearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.IntrmyAgt");
            mtClearChannelId = mx_to_mtClearingIdentifierAndChannel(bodyHdrParentElementName + ".Ntfctn.IntrmyAgt");
        }
        if(counts2>0){
            bicCode = mx_to_mtBICFI(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").IntrmyAgt");
            mtClearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").IntrmyAgt");
            mtClearChannelId = mx_to_mtClearingIdentifierAndChannel(bodyHdrParentElementName + ".Ntfctn.Itm("+0+").IntrmyAgt");
        }
        String mtAccount = "";
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(mtClearChannelId)){
                mtAccount = mtClearChannelId;
            } else {
                mtAccount = mtClearSystemId;
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else {
            String name = "";
            String countryCode = "";
            int addressLineCount = 0;
            String mtNameAddress = "";
            if(counts1>0){
                name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.IntrmyAgt.FinInstnId.Nm");
                countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.IntrmyAgt.FinInstnId.PstlAdr.Ctry");
                addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.IntrmyAgt.FinInstnId.PstlAdr.AdrLine");
                if (addressLineCount > 0) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.IntrmyAgt.FinInstnId");
                } else if (StringUtil.isNotEmpty(countryCode)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".Ntfctn.IntrmyAgt.FinInstnId", false);
                } else if (StringUtil.isNotEmpty(name)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.IntrmyAgt.FinInstnId");
                }
            }
            if(counts2>0){
                name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId.Nm");
                countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId.PstlAdr.Ctry");
                addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId.PstlAdr.AdrLine");
                if (addressLineCount > 0) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId");
                } else if (StringUtil.isNotEmpty(countryCode)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId", false);
                } else if (StringUtil.isNotEmpty(name)) {
                    mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".Ntfctn.Itm("+0+").IntrmyAgt.FinInstnId");
                }
            }
            if (StringUtil.isEmpty(mtNameAddress)) return;//如果name和地址不存在，返回。
            if (StringUtil.isNotEmpty(mtClearChannelId)) {
                mtAccount = mtClearChannelId;
            } else if (StringUtil.isNotEmpty(mtClearSystemId)) {
                mtAccount = mtClearSystemId;
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            tags.add(new Tag(name_D, value));
        }
    }
}
