package com.brilliance.swift.mx2mt.mt920.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field12Generate extends AbstractMx2MtTagsGenerate {

    private static String NAME = "12";

    private int index = -1; //存在多个域循环, 表示xml节点的下标.

    public Field12Generate(int index) {
        this.index = index;
    }

    @Override
    public void tagGenerate() throws SwiftException {
        if (index > -1) {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String msgNameId = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq(" + index + ").ReqdMsgNmId");
            if (StringUtil.isNotEmpty(msgNameId)) {
                String value = "";
                if (msgNameId.startsWith("camt.053")) {
                    value = Mx2MtConstants.MT_TYPE_950;
                } else if (msgNameId.startsWith("camt.052")) {
                    value = Mx2MtConstants.MT_TYPE_942;
                } else if (msgNameId.contains(Mx2MtConstants.MT_TYPE_941)) {
                    value = Mx2MtConstants.MT_TYPE_941;
                } else if (msgNameId.contains(Mx2MtConstants.MT_TYPE_942)) {
                    value = Mx2MtConstants.MT_TYPE_942;
                } else if (msgNameId.contains(Mx2MtConstants.MT_TYPE_940)) {
                    value = Mx2MtConstants.MT_TYPE_940;
                } else if (msgNameId.contains(Mx2MtConstants.MT_TYPE_950)) {
                    value = Mx2MtConstants.MT_TYPE_950;
                }
                if (StringUtil.isNotEmpty(value)) {
                    tags.add(new Tag(NAME, value));
                }
            }
        }

    }
}
