package com.brilliance.swift.mx2mt.mt920.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

public class Field34CGenerate extends AbstractMx2MtTagsGenerate {

    private static String NAME = "34";

    private int index = -1; //存在多个域循环, 表示xml节点的下标.

    public Field34CGenerate(int index) {
        this.index = index;
    }

    @Override
    public void tagGenerate() throws SwiftException {
        if (index > -1) {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            int floorLimtCount = getXmlNodeCounts(bodyHdrParentElementName, document, "RptgReq("+index+").ReqdTxTp.FlrLmt");
            if (floorLimtCount > 0) {
                for (int i=0; i<floorLimtCount; i++) {
                    String crdrIndicator = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq("+index+").ReqdTxTp.FlrLmt("+i+").CdtDbtInd");
                    String amt = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq("+index+").ReqdTxTp.FlrLmt("+i+").Amt");
                    String ccy = getXmlNodeValue(bodyHdrParentElementName, document, "RptgReq("+index+").ReqdTxTp.FlrLmt("+i+").Amt@Ccy");
                    if ("CRED".equals(crdrIndicator)) {
                        String value = ccy + "C" + NumberUtil.formatAmt(new BigDecimal(amt), ccy);
                        tags.add(new Tag(NAME, value));
                        break;
                    }
                }
            }
        }
    }
}
