package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field13DGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "13D";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String CreationDateTime = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.CreDtTm");
        String dateStr = "";
        if(StringUtil.isNotEmpty(CreationDateTime)){
            dateStr = CreationDateTime;
        }else {
            dateStr = getXmlNodeValue(grpHdrParentElementName, document, "GrpHdr.CreDtTm");
        }
        String mxTimeOffset = dateStr.substring(11);
        String mtDate = mXToMTDate(dateStr.substring(0,10));
        String[] split = mxTimeOffset.split(":");
        String mtTimeOffset = "";
        if(split.length==4){
            if(split[0].length()==1){
                split[0] = "0"+split[0];
            }
            mtTimeOffset = split[0] + split[1] + split[2].substring(2) + split[3];
        }
        tags.add(new Tag(name, mtDate+mtTimeOffset));
    }
}
