package com.brilliance.swift.mx2mt.mtn99.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field20Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "20";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String messageId = getXmlNodeValue(grpHdrParentElementName, document, "GrpHdr.MsgId");
        if (StringUtil.isNotEmpty(messageId)) {
            if (messageId.length() > 16) {
                messageId = messageId.substring(0, 15) + "+";
            }
            String value = messageId;
            if (value.startsWith("/") || value.endsWith("/") || value.contains("//")) {
                value = Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE;
            }
            tags.add(new Tag(name, value));
        }
    }
}
