package com.brilliance.swift.swiftdto2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.ServiceLevel;
import com.brilliance.swift.vo.common.ServiceLevelCode;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag23BGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "23B";

    @Override
    public void tagGenerate() throws SwiftException {
        VoCustomerCreditTransfer customerCreditTransfer = (VoCustomerCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        ServiceLevel serviceLevel = customerCreditTransfer.getServiceLevel();
        if (serviceLevel != null) {
            String value = ServiceLevelCode.SDVA.equals(serviceLevel.getCode()) ? "CRED" : serviceLevel.getProprietary();
            tags.add(new Tag(name, value));
        }
    }
}
