package com.brilliance.swift.swiftdto2mt.mt103.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.brilliance.swift.vo.common.ChargeInfo;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mx.dic.ChargeBearerType1Code;

import java.util.List;

public class Tag71Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name_A = "71A";

    private String name_F = "71F";

    private String name_G = "71G";

    @Override
    public void tagGenerate() throws SwiftException {
        VoCustomerCreditTransfer customerCreditTransfer = (VoCustomerCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (customerCreditTransfer.getChargeFor() != null) {
            String value = "";
            if (ChargeBearerType1Code.CRED.value().equals(customerCreditTransfer.getChargeFor().value())) {
                value = "BEN";
            } else if (ChargeBearerType1Code.DEBT.value().equals(customerCreditTransfer.getChargeFor().value())) {
                value = "OUR";
            } else if (ChargeBearerType1Code.SHAR.value().equals(customerCreditTransfer.getChargeFor().value())) {
                value = "SHA";
            }
            tags.add(new Tag(name_A, value));
            List<ChargeInfo> chargeInfos = customerCreditTransfer.getChargeInfoList();
            if (chargeInfos.size() > 0) {
                for (ChargeInfo chargeInfo : chargeInfos) {
                    CcyFormatAmount chargeCcyFormatAmount = chargeInfo.getAmt();
                    if (chargeCcyFormatAmount != null) {
                        String ccy = chargeCcyFormatAmount.getCcy();
                        String amt = NumberUtil.formatAmt(chargeCcyFormatAmount.getAmt(), ccy);
                        if ("SHA".equals(value) || "BEN".equals(value)) {
                            tags.add(new Tag(name_F, ccy+amt));
                        } else if ("OUR".equals(value)) {
                            tags.add(new Tag(name_G, ccy+amt));
                        }
                    }
                }
            }
        }
    }
}
