package com.brilliance.swift.swiftdto2mt.mt202.impl.cov;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.CcyFormatAmount;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Tag33BGenerate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "33B";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        VoCustomerCreditTransfer customerCreditTransfer = financialInstitutionCreditTransfer.getUnderCustomerCreditTransfer();
        if (customerCreditTransfer == null) return;
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        if (customerCreditTransfer.getInstructedCcyFormatAmount() != null) {
            CcyFormatAmount instructedCcyFormatAmount = customerCreditTransfer.getInstructedCcyFormatAmount();
            String ccy = instructedCcyFormatAmount.getCcy();
            String amt = NumberUtil.formatAmt(instructedCcyFormatAmount.getAmt(), ccy);
            tags.add(new Tag(name,ccy+amt));
        }
    }
}

