package com.brilliance.swift.swiftdto2mt.mt202.impl.cov;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.VoCustomerCreditTransfer;
import com.brilliance.swift.vo.VoFinancialInstitutionCreditTransfer;
import com.brilliance.swift.vo.common.InstructionForCreditAgent;
import com.brilliance.swift.vo.common.InstructionForNextAgent;
import com.brilliance.swift.vo.common.PartyDto;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.ArrayList;
import java.util.List;

public class Tag72Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "72";

    @Override
    public void tagGenerate() throws SwiftException {
        VoFinancialInstitutionCreditTransfer financialInstitutionCreditTransfer = (VoFinancialInstitutionCreditTransfer)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
        VoCustomerCreditTransfer customerCreditTransfer = financialInstitutionCreditTransfer.getUnderCustomerCreditTransfer();
        if (customerCreditTransfer == null) return;
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        List<String> list = new ArrayList<>();
        PartyDto preInstgAgtParty = customerCreditTransfer.getPreInstgAgtParty();
        if (preInstgAgtParty != null) {
            String bicCode = preInstgAgtParty.getPartyBic();
            String name = preInstgAgtParty.getPartyName();
            if (StringUtil.isNotEmpty(bicCode)) {
                bicCode = Mx2MtConstants.INS + bicCode;
                list.addAll(StringUtil.outStringList(bicCode, 35, "//"));
            } else if (StringUtil.isNotEmpty(name)) {
                name = Mx2MtConstants.INS + name;
                list.addAll(StringUtil.outStringList(name, 35, "//"));
            }
        }
        InstructionForCreditAgent instForCrdAgt = customerCreditTransfer.getInstForCrdAgt();
        if (instForCrdAgt != null && StringUtil.isNotEmpty(instForCrdAgt.getInstrInf())) {
            String instrInfo = Mx2MtConstants.ACC + instForCrdAgt.getInstrInf();
            list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
        }
        InstructionForNextAgent instForNxtAgt = customerCreditTransfer.getInstForNxtAgt();
        if (instForNxtAgt != null && StringUtil.isNotEmpty(instForNxtAgt.getInstrInf())) {
            String instrInfo = Mx2MtConstants.REC + instForNxtAgt.getInstrInf();
            list.addAll(StringUtil.outStringList(instrInfo, 35, "//"));
        }
        String value = "";
        for (int i=0; i<list.size(); i++) {
            if (i == 6) break;
            if (i == 0) {
                value += list.get(i);
            } else {
                value += Mx2MtConstants.NEW_LINE + list.get(i);
            }
        }
        if (StringUtil.isNotEmpty(value)) {
            tags.add(new Tag(name, value));
        }
    }
}

