package com.brilliance.swift.swiftdto2mt.mt900910.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mt.AbstractSwiftDto2MtTagGenerate;
import com.brilliance.swift.swiftdto2mt.SwiftDto2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.BankToCustomerDebitCreditNotification;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;


public class Tag72Generate extends AbstractSwiftDto2MtTagGenerate {

    private String name = "72";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            BankToCustomerDebitCreditNotification bankToCustomerDebitCreditNotification = (BankToCustomerDebitCreditNotification)context.get(SwiftDto2MtContextIdentifier.SWIFT_DTO_OBJ, true);
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            if (StringUtil.isNotEmpty(bankToCustomerDebitCreditNotification.getAddtlTxInf())) {
                String addtlTxInf = StringUtil.getStringByEnter(bankToCustomerDebitCreditNotification.getAddtlTxInf(), 35, 6);
                tags.add(new Tag(name, addtlTxInf));
            }
        }catch (Exception e){
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
