package com.brilliance.swift.swiftdto2mx;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.swiftdto2mx.camt053001.v08.SwiftDto2MxCamt053001Creator;
import com.brilliance.swift.swiftdto2mx.camt054001.v08.SwiftDto2MxCamt054001Creator;
import com.brilliance.swift.swiftdto2mx.pacs008001.v09.SwiftDto2MxPacs008001Creator;
import com.brilliance.swift.swiftdto2mx.pacs009001.v09.SwiftDto2MxPacs009001Creator;
import com.brilliance.swift.vo.SwiftDto;

public class SwiftDto2MxCreatorManager {

    public String swiftDto2Mx(SwiftDto swiftDto, String fileOutputPath) throws SwiftException {
        SwiftDto2MxContext context = new SwiftDto2MxContext();
        context.set(SwiftDto2MxContextIdentifier.SWIFT_DTO_OBJ, swiftDto);
        context.set(SwiftDto2MxContextIdentifier.MX_OUTPUT_FILE_PATH, fileOutputPath);
        AbstractSwiftDto2MxCreator creator = getCreator(swiftDto.getSwiftHeader().getMessageType());
        creator.setContext(context).create();
        String xmlStr = (String)context.get(SwiftDto2MxContextIdentifier.MX_XML);
        return xmlStr;
    }

    public AbstractSwiftDto2MxCreator getCreator(String messageType) {
        if ("pacs.008.001".equals(messageType)) {
            return new SwiftDto2MxPacs008001Creator();
        } else if ("pacs.009.001".equals(messageType)) {
            return new SwiftDto2MxPacs009001Creator();
        } else if("camt.054.001".equals(messageType)){
            return new SwiftDto2MxCamt054001Creator();
        } else if("camt.053.001".equals(messageType)){
            return new SwiftDto2MxCamt053001Creator();
        } else {
            throw new SwiftException("Invalid message type");
        }
    }
}
