package com.brilliance.swift.vo;

import com.brilliance.swift.vo.common.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @author zh
 * @create 2022-04-21 16:56
 */
public class BankToCustomerStatement extends SwiftDto{

    protected TransactionReference txnRef;

    protected PartyAccount account;

    protected String pgNb;

    protected String elctrncSeqNb;

    protected CashBalance openingBalance;

    protected List<ReportEntry> reportEntries;

    protected CashBalance closingBalance;

    protected CashBalance closingAvailableBalance;

    protected List<CashBalance> forwardAvailableBalances;

    protected String additionalStatementInformation;

    public List<ReportEntry> getReportEntries() {
        if(reportEntries == null){
            reportEntries = new ArrayList<>();
        }
        return reportEntries;
    }

    public BankToCustomerStatement addReportEntry(ReportEntry reportEntry) {
        getReportEntries().add(reportEntry);
        return this;
    }

    public List<CashBalance> getForwardAvailableBalances() {
        if(forwardAvailableBalances == null){
            forwardAvailableBalances = new ArrayList<>();
        }
        return forwardAvailableBalances;
    }

    public BankToCustomerStatement addForwardAvailableBalance(CashBalance cashBalance) {
        getForwardAvailableBalances().add(cashBalance);
        return this;
    }

    public TransactionReference getTxnRef() {
        return txnRef;
    }

    public void setTxnRef(TransactionReference txnRef) {
        this.txnRef = txnRef;
    }

    public PartyAccount getAccount() {
        return account;
    }

    public void setAccount(PartyAccount account) {
        this.account = account;
    }

    public String getPgNb() {
        return pgNb;
    }

    public void setPgNb(String pgNb) {
        this.pgNb = pgNb;
    }

    public String getElctrncSeqNb() {
        return elctrncSeqNb;
    }

    public void setElctrncSeqNb(String elctrncSeqNb) {
        this.elctrncSeqNb = elctrncSeqNb;
    }

    public CashBalance getOpeningBalance() {
        return openingBalance;
    }

    public void setOpeningBalance(CashBalance openingBalance) {
        this.openingBalance = openingBalance;
    }

    public CashBalance getClosingBalance() {
        return closingBalance;
    }

    public void setClosingBalance(CashBalance closingBalance) {
        this.closingBalance = closingBalance;
    }

    public CashBalance getClosingAvailableBalance() {
        return closingAvailableBalance;
    }

    public void setClosingAvailableBalance(CashBalance closingAvailableBalance) {
        this.closingAvailableBalance = closingAvailableBalance;
    }

    public String getAdditionalStatementInformation() {
        return additionalStatementInformation;
    }

    public void setAdditionalStatementInformation(String additionalStatementInformation) {
        this.additionalStatementInformation = additionalStatementInformation;
    }
}
