package com.brilliance.swift.vo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.apache.commons.lang3.Validate;

import java.io.*;
import java.util.Date;

public class SwiftDto implements Serializable {

    private static final long serialVersionUID = 2296248553989810638L;

    protected SwiftHeader swiftHeader;

    public SwiftHeader getSwiftHeader() {
        return swiftHeader;
    }

    public void setSwiftHeader(SwiftHeader swiftHeader) {
        this.swiftHeader = swiftHeader;
    }

    public String toJson() {
        final Gson gson = new GsonBuilder()
                .registerTypeAdapter(SwiftDto.class, new SwiftDtoAdapter())
                .registerTypeAdapter(Date.class, new DateAdapter())
                .setPrettyPrinting()
                .create();
        return gson.toJson(this, this.getClass());
    }

    public static SwiftDto fromJson(String json) {
        final Gson gson = new GsonBuilder()
                .registerTypeAdapter(SwiftDto.class, new SwiftDtoAdapter())
                .registerTypeAdapter(Date.class, new DateAdapter())
                .create();
        return gson.fromJson(json, SwiftDto.class);
    }

    public void write(final File file) throws IOException {
        Validate.notNull(file, "the file to write cannot be null");
        if (!file.exists()) {
            file.createNewFile();
        }
        final FileOutputStream stream = new FileOutputStream(file.getAbsoluteFile());
        write(stream);
        stream.close();
    }

    public void write(final OutputStream stream) throws IOException {
        Validate.notNull(stream, "the stream to write cannot be null");
        stream.write(toJson().getBytes("UTF-8"));
    }
}
