package com.brilliance.swift.vo.common;

public enum ClearingChannelCode {

    /**
     * Clearing channel is a real-time gross settlement system.
     *
     */
    RTGS,

    /**
     * Clearing channel is a real-time net settlement system.
     *
     */
    RTNS,

    /**
     * Clearing channel is a mass payment net settlement system.
     *
     */
    MPNS,

    /**
     * Payment through internal book transfer.
     *
     */
    BOOK;

    public String value() {
        return name();
    }

    public static ClearingChannelCode fromValue(String v) {
        return valueOf(v);
    }
}
