package com.brilliance.swift.vo.common;

public enum PurposeCode {

    BKDF("BankLoanDelayedDrawFunding"),
    BKFE("BankLoanFees"),
    BKFM("BankLoanFundingMemo"),
    BKIP("BankLoanAccruedInterestPayment"),
    BKPP("BankLoanPrincipalPaydown"),
    CBLK("CardBulkClearing"),
    CDCB("CardPaymentWithCashBack"),
    CDCD("CashDisbursementCashSettlement"),
    CDCS("CashDisbursementWithSurcharging"),
    CDDP("CardDeferredPayment"),
    CDOC("OriginalCredit"),
    CDQC("QuasiCash"),
    ETUP("EPurseTopUp"),
    FCOL("FeeCollection"),
    MTUP("MobileTopUp"),
    ACCT("AccountManagement"),
    CASH("CashManagementTransfer"),
    COLL("CollectionPayment"),
    CSDB("CashDisbursementCashManagement"),
    DEPT("Deposit"),
    INTC("IntraCompanyPayment"),
    INTP("IntraPartyPayment"),
    LIMA("LiquidityManagement"),
    NETT("Netting"),
    BFWD("BondForward"),
    CCIR("CrossCurrencyIRS"),
    CCPC("CCPClearedInitialMargin"),
    CCPM("CCPClearedVariationMargin"),
    CCSM("CCPClearedInitialMarginSegregatedCash"),
    CRDS("CreditDefaultSwap"),
    CRPR("CrossProduct"),
    CRSP("CreditSupport"),
    CRTL("CreditLine"),
    EQPT("EquityOption"),
    EQUS("EquitySwap"),
    EXPT("ExoticOption"),
    EXTD("ExchangeTradedDerivatives"),
    FIXI("FixedIncome"),
    FWBC("ForwardBrokerOwnedCashCollateral"),
    FWCC("ForwardClientOwnedCashCollateral"),
    FWSB("ForwardBrokerOwnedCashCollateralSegregated"),
    FWSC("ForwardClientOwnedSegregatedCashCollateral"),
    MARG("DailyMarginOnListedDerivatives"),
    MBSB("MBSBrokerOwnedCashCollateral"),
    MBSC("MBSClientOwnedCashCollateral"),
    MGCC("FuturesInitialMargin"),
    MGSC("FuturesInitialMarginClientOwnedSegregatedCashCollateral"),
    OCCC("ClientOwnedOCCPledgedCollateral"),
    OPBC("OTCOptionBrokerOwnedCashCollateral"),
    OPCC("OTCOptionClientOwnedCashCollateral"),
    OPSB("OTCOptionBrokerOwnedSegregatedCashCollateral"),
    OPSC("OTCOptionClientOwnedCashSegregatedCashCollateral"),
    OPTN("FXOption"),
    OTCD("OTCDerivatives"),
    REPO("RepurchaseAgreement"),
    RPBC("BilateralRepoBrokerOwnedCollateral"),
    RPCC("RepoClientOwnedCollateral"),
    RPSB("BilateralRepoBrokerOwnedSegregatedCashCollateral"),
    RPSC("BilateralRepoClientOwnedSegregatedCashCollateral"),
    RVPO("ReverseRepurchaseAgreement"),
    SBSC("SecuritiesBuySellSellBuyBack"),
    SCIE("SingleCurrencyIRSExotic"),
    SCIR("SingleCurrencyIRS"),
    SCRP("SecuritiesCrossProducts"),
    SHBC("BrokerOwnedCollateralShortSale"),
    SHCC("ClientOwnedCollateralShortSale"),
    SHSL("ShortSell"),
    SLEB("SecuritiesLendingAndBorrowing"),
    SLOA("SecuredLoan"),
    SWBC("SwapBrokerOwnedCashCollateral"),
    SWCC("SwapClientOwnedCashCollateral"),
    SWPT("Swaption"),
    SWSB("SwapsBrokerOwnedSegregatedCashCollatera"),
    SWSC("SwapsClientOwnedSegregatedCashCollateral"),
    TBAS("ToBeAnnounced"),
    TBBC("TBABrokerOwnedCashCollateral"),
    TBCC("TBAClientOwnedCashCollateral"),
    TRCP("TreasuryCrossProduct"),
    AGRT("AgriculturalTransfer"),
    AREN("AccountsReceivablesEntry"),
    BEXP("BusinessExpenses"),
    BOCE("BackOfficeConversionEntry"),
    COMC("CommercialPayment"),
    CPYR("Copyright"),
    GDDS("PurchaseSaleOfGoods"),
    GDSV("PurchaseSaleOfGoodsAndServices"),
    GSCB("PurchaseSaleOfGoodsAndServicesWithCashBack"),
    LICF("LicenseFee"),
    MP2B("MobileP2BPayment"),
    POPE("PointOfPurchaseEntry"),
    ROYA("Royalties"),
    SCVE("PurchaseSaleOfServices"),
    SERV("ServiceCharges"),
    SUBS("Subscription"),
    SUPP("SupplierPayment"),
    TRAD("Commercial"),
    CHAR("CharityPayment"),
    COMT("ConsumerThirdPartyConsolidatedPayment"),
    MP2P("MobileP2PPayment"),
    ECPG("GuaranteedEPayment"),
    ECPR("EPaymentReturn"),
    ECPU("NonGuaranteedEPayment"),
    EPAY("Epayment"),
    CLPR("CarLoanPrincipalRepayment"),
    COMP("CompensationPayment"),
    DBTC("DebitCollectionPayment"),
    GOVI("GovernmentInsurance"),
    HLRP("PropertyLoanRepayment"),
    HLST("PropertyLoanSettlement"),
    INPC("InsurancePremiumCar"),
    INPR("InsurancePremiumRefund"),
    INSC("PaymentOfInsuranceClaim"),
    INSU("InsurancePremium"),
    INTE("Interest"),
    LBRI("LaborInsurance"),
    LIFI("LifeInsurance"),
    LOAN("Loan"),
    LOAR("LoanRepayment"),
    PENO("PaymentBasedOnEnforcementOrder"),
    PPTI("PropertyInsurance"),
    RELG("RentalLeaseGeneral"),
    RINP("RecurringInstallmentPayment"),
    TRFD("TrustFund"),
    FORW("ForwardForeignExchange"),
    FXNT("ForeignExchangeRelatedNetting"),
    ADMG("AdministrativeManagement"),
    ADVA("AdvancePayment"),
    BCDM("BearerChequeDomestic"),
    BCFG("BearerChequeForeign"),
    BLDM("BuildingMaintenance"),
    BNET("BondForwardNetting"),
    CBFF("CapitalBuilding"),
    CBFR("CapitalBuildingRetirement"),
    CCRD("CreditCardPayment"),
    CDBL("CreditCardBill"),
    CFEE("CancellationFee"),
    CGDD("CardGeneratedDirectDebit"),
    CORT("TradeSettlementPayment"),
    COST("Costs"),
    CPKC("CarparkCharges"),
    DCRD("DebitCardPayment"),
    DSMT("PrintedOrderDisbursement"),
    DVPM("DeliverAgainstPayment"),
    EDUC("Education"),
    FACT("FactorUpdateRelatedPayment"),
    FAND("FinancialAidInCaseOfNaturalDisaster"),
    FCPM("LatePaymentOfFeesAndCharges"),
    FEES("PaymentOfFees"),
    GIFT("Gift"),
    GOVT("GovernmentPayment"),
    ICCP("IrrevocableCreditCardPayment"),
    IDCP("IrrevocableDebitCardPayment"),
    IHRP("InstalmentHirePurchaseAgreement"),
    INSM("Installment"),
    IVPT("InvoicePayment"),
    MCDM("MultiCurrenyChequeDomestic"),
    MCFG("MultiCurrenyChequeForeign"),
    MSVC("MultipleServiceTypes"),
    NOWS("NotOtherwiseSpecified"),
    OCDM("OrderChequeDomestic"),
    OCFG("OrderChequeForeign"),
    OFEE("OpeningFee"),
    OTHR("Other"),
    PADD("PreauthorizedDebit"),
    PTSP("PaymentTerms"),
    RCKE("RepresentedCheckEntry"),
    RCPT("ReceiptPayment"),
    REBT("Rebate"),
    REFU("Refund"),
    RENT("Rent"),
    REOD("AccountOverdraftRepayment"),
    RIMB("ReimbursementOfAPreviousErroneousTransaction"),
    RPNT("BilateralRepoInternetNetting"),
    RRBN("RoundRobin"),
    RRCT("ReimbursementReceivedCreditTransfer"),
    RRTP("RelatedRequestToPay"),
    RVPM("ReceiveAgainstPayment"),
    SLPI("PaymentSlipInstruction"),
    SPLT("SplitPayments"),
    STDY("Study"),
    TBAN("TBAPairOffNetting"),
    TBIL("TelecommunicationsBill"),
    TCSC("TownCouncilServiceCharges"),
    TELI("TelephoneInitiatedTransaction"),
    TMPG("TMPGClaimPayment"),
    TPRI("TriPartyRepoInterest"),
    TPRP("TriPartyRepoNetting"),
    TRNC("TruncatedPaymentSlip"),
    TRVC("TravellerCheque"),
    WEBI("InternetInitiatedTransaction"),
    IPAY("InstantPayments"),
    IPCA("InstantPaymentsCancellation"),
    IPDO("InstantPaymentsForDonations"),
    IPEA("InstantPaymentsInECommerceWithoutAddressData"),
    IPEC("InstantPaymentsInECommerceWithAddressData"),
    IPEW("InstantPaymentsInECommerce"),
    IPPS("InstantPaymentsAtPOS"),
    IPRT("InstantPaymentsReturn"),
    IPU2("InstantPaymentsUnattendedVendingMachineWith2FA"),
    IPUW("InstantPaymentsUnattendedVendingMachineWithout2FA"),
    ANNI("Annuity"),
    CAFI("CustodianManagementFeeInhouse"),
    CFDI("CapitalFallingDueInhouse"),
    CMDT("CommodityTransfer"),
    DERI("Derivatives"),
    DIVD("Dividend"),
    FREX("ForeignExchange"),
    HEDG("Hedging"),
    INVS("InvestmentAndSecurities"),
    PRME("PreciousMetal"),
    SAVG("Savings"),
    SECU("Securities"),
    SEPI("SecuritiesPurchaseInhouse"),
    TREA("TreasuryPayment"),
    UNIT("UnitTrustPurchase"),
    FNET("FuturesNettingPayment"),
    FUTR("Futures"),
    ANTS("AnesthesiaServices"),
    CVCF("ConvalescentCareFacility"),
    DMEQ("DurableMedicaleEquipment"),
    DNTS("DentalServices"),
    HLTC("HomeHealthCare"),
    HLTI("HealthInsurance"),
    HSPC("HospitalCare"),
    ICRF("IntermediateCareFacility"),
    LTCF("LongTermCareFacility"),
    MAFC("MedicalAidFundContribution"),
    MARF("MedicalAidRefund"),
    MDCS("MedicalServices"),
    VIEW("VisionCare"),
    CDEP("CreditDefaultEventPayment"),
    SWFP("SwapContractFinalPayment"),
    SWPP("SwapContractPartialPayment"),
    SWRS("SwapContractResetPayment"),
    SWUF("SwapContractUpfrontPayment"),
    ADCS("AdvisoryDonationCopyrightServices"),
    AEMP("ActiveEmploymentPolicy"),
    ALLW("Allowance"),
    ALMY("AlimonyPayment"),
    BBSC("BabyBonusScheme"),
    BECH("ChildBenefit"),
    BENE("UnemploymentDisabilityBenefit"),
    BONU("BonusPayment"),
    CCHD("CashCompensationHelplessnessDisability"),
    COMM("Commission"),
    CSLP("CompanySocialLoanPaymentToBank"),
    GFRP("GuaranteeFundRightsPayment"),
    GVEA("AustrianGovernmentEmployeesCategoryA"),
    GVEB("AustrianGovernmentEmployeesCategoryB"),
    GVEC("AustrianGovernmentEmployeesCategoryC"),
    GVED("AustrianGovernmentEmployeesCategoryD"),
    GWLT("GovermentWarLegislationTransfer"),
    HREC("HousingRelatedContribution"),
    PAYR("Payroll"),
    PEFC("PensionFundContribution"),
    PENS("PensionPayment"),
    PRCP("PricePayment"),
    RHBS("RehabilitationSupport"),
    SALA("SalaryPayment"),
    SPSP("SalaryPensionSumPayment"),
    SSBE("SocialSecurityBenefit"),
    LBIN("LendingBuyInNetting"),
    LCOL("LendingCashCollateralFreeMovement"),
    LFEE("LendingFees"),
    LMEQ("LendingEquityMarkedToMarketCashCollateral"),
    LMFI("LendingFixedIncomeMarkedToMarketCashCollateral"),
    LMRK("LendingUnspecifiedTypeOfMarkedToMarketCashCollateral"),
    LREB("LendingRebatePayments"),
    LREV("LendingRevenuePayments"),
    LSFL("LendingClaimPayment"),
    ESTX("EstateTax"),
    FWLV("ForeignWorkerLevy"),
    GSTX("GoodsServicesTax"),
    HSTX("HousingTax"),
    INTX("IncomeTax"),
    NITX("NetIncomeTax"),
    PTXP("PropertyTax"),
    RDTX("RoadTax"),
    TAXS("TaxPayment"),
    VATX("ValueAddedTaxPayment"),
    WHLD("WithHolding"),
    TAXR("TaxRefund"),
    B112("TrailerFeePayment"),
    BR12("TrailerFeeRebate"),
    TLRF("NonUSMutualFundTrailerFeePayment"),
    TLRR("NonUSMutualFundTrailerFeeRebatePayment"),
    AIRB("Air"),
    BUSB("Bus"),
    FERB("Ferry"),
    RLWY("Railway"),
    TRPT("RoadPricing"),
    CBTV("CableTVBill"),
    ELEC("ElectricityBill"),
    ENRG("Energies"),
    GASB("GasBill"),
    NWCH("NetworkCharge"),
    NWCM("NetworkCommunication"),
    OTLC("OtherTelecomRelatedBill"),
    PHON("TelephoneBill"),
    UBIL("Utilities"),
    WTER("WaterBill"),
    BOND("Bonds"),
    CABD("CorporateActions-Bonds"),
    CAEQ("CorporateActions-Equities"),
    CBCR("CreditCard"),
    DBCR("DebitCard"),
    DICL("Diners"),
    EQTS("Equities"),
    FLCR("FleetCard"),
    EFTC("LowValueCredit"),
    EFTD("LowValueDebit"),
    MOMA("MoneyMarket"),
    RAPI("RapidPaymentInstruction"),
    GAMB("GamblingOrWageringPayment"),
    LOTT("LotteryPayment"),
    AMEX("Amex"),
    SASW("ATM"),
    AUCO("AuthenticatedCollections"),
    PCOM("PropertyCompletionPayment"),
    PDEP("PropertyDeposit"),
    PLDS("PropertyLoanDisbursement"),
    PLRF("PropertyLoanRefinancing"),
    GAFA("GovernmentFamilyAllowance"),
    GAHO("GovernmentHousingAllowance");

    PurposeCode(String s) {}
    public String value() {
        return name();
    }
}
