
package com.prowidesoftware.swift.model.mx;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.dic.Camt03300101;
import com.prowidesoftware.swift.model.mx.dic.Case;
import com.prowidesoftware.swift.model.mx.dic.CaseAssignment;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for camt.033.001.01 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "camt03300101"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:camt.033.001.01")
public class MxCamt03300101
    extends AbstractMX
{

    @XmlElement(name = "camt.033.001.01", required = true)
    protected Camt03300101 camt03300101;
    public final static transient String BUSINESS_PROCESS = "camt";
    public final static transient int FUNCTIONALITY = 33;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {Camt03300101 .class, Case.class, CaseAssignment.class, MxCamt03300101 .class };
    public final static transient String NAMESPACE = "urn:swift:xsd:camt.033.001.01";

    public MxCamt03300101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxCamt03300101(final String xml) {
        this();
        MxCamt03300101 tmp = parse(xml);
        camt03300101 = tmp.getCamt03300101();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxCamt03300101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the camt03300101 property.
     * 
     * @return
     *     possible object is
     *     {@link Camt03300101 }
     *     
     */
    public Camt03300101 getCamt03300101() {
        return camt03300101;
    }

    /**
     * Sets the value of the camt03300101 property.
     * 
     * @param value
     *     allowed object is
     *     {@link Camt03300101 }
     *     
     */
    public MxCamt03300101 setCamt03300101(Camt03300101 value) {
        this.camt03300101 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxCamt03300101 parse(String xml) {
        return ((MxCamt03300101) MxReadImpl.parse(MxCamt03300101 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxCamt03300101 parse(String xml, MxRead parserImpl) {
        return ((MxCamt03300101) parserImpl.read(MxCamt03300101 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxCamt03300101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxCamt03300101 message
     * @return
     *     a new instance of MxCamt03300101
     */
    public final static MxCamt03300101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxCamt03300101 .class);
    }

}
