
package com.prowidesoftware.swift.model.mx.sys;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.AbstractMX;
import com.prowidesoftware.swift.model.mx.MxRead;
import com.prowidesoftware.swift.model.mx.MxReadImpl;
import com.prowidesoftware.swift.model.mx.dic.AbstractReportDescription;
import com.prowidesoftware.swift.model.mx.dic.ReportDescription;
import com.prowidesoftware.swift.model.mx.sys.dic.GetUndeliveredMessagesRequest;
import com.prowidesoftware.swift.model.mx.sys.dic.MsgServiceCode;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for xsys.004.001.01 ISO 20022 message.
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
        "xsys00400101"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:xsys.004.001.01")
public class MxXsys00400101
        extends AbstractMX {

    @XmlElement(name = "xsys.004.001.01", required = true)
    protected GetUndeliveredMessagesRequest xsys00400101;
    public final static transient String BUSINESS_PROCESS = "xsys";
    public final static transient int FUNCTIONALITY = 4;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 1;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[]{AbstractReportDescription.class, GetUndeliveredMessagesRequest.class, MsgServiceCode.class, MxXsys00400101.class, ReportDescription.class};
    public final static transient String NAMESPACE = "urn:swift:xsd:xsys.004.001.01";

    public MxXsys00400101() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     */
    public MxXsys00400101(final String xml) {
        this();
        MxXsys00400101 tmp = parse(xml);
        xsys00400101 = tmp.getXsys00400101();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     */
    public MxXsys00400101(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the xsys00400101 property.
     *
     * @return possible object is
     * {@link GetUndeliveredMessagesRequest }
     */
    public GetUndeliveredMessagesRequest getXsys00400101() {
        return xsys00400101;
    }

    /**
     * Sets the value of the xsys00400101 property.
     *
     * @param value allowed object is
     *              {@link GetUndeliveredMessagesRequest }
     */
    public MxXsys00400101 setXsys00400101(GetUndeliveredMessagesRequest value) {
        this.xsys00400101 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     */
    public static MxXsys00400101 parse(String xml) {
        return ((MxXsys00400101) MxReadImpl.parse(MxXsys00400101.class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     *
     * @param parserImpl an MX unmarshall implementation
     * @since 9.0.1
     */
    public static MxXsys00400101 parse(String xml, MxRead parserImpl) {
        return ((MxXsys00400101) parserImpl.read(MxXsys00400101.class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxXsys00400101 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance
     * see {@link AbstractMX#fromJson(String)}
     *
     * @param json a JSON representation of an MxXsys00400101 message
     * @return a new instance of MxXsys00400101
     * @since 7.10.2
     */
    public final static MxXsys00400101 fromJson(String json) {
        return AbstractMX.fromJson(json, MxXsys00400101.class);
    }

}
