
package com.prowidesoftware.swift.model.mx.sys;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.AbstractMX;
import com.prowidesoftware.swift.model.mx.MxRead;
import com.prowidesoftware.swift.model.mx.MxReadImpl;
import com.prowidesoftware.swift.model.mx.sys.dic.QueueStatusReportRequest;
import com.prowidesoftware.swift.model.mx.sys.dic.ReportCriteriav2;
import com.prowidesoftware.swift.model.mx.sys.dic.ReportOptionCode;
import com.prowidesoftware.swift.model.mx.sys.dic.SwBooleanIndicator;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for xsys.008.001.02 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "xsys00800102"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:xsys.008.001.02")
public class MxXsys00800102
    extends AbstractMX
{

    @XmlElement(name = "xsys.008.001.02", required = true)
    protected QueueStatusReportRequest xsys00800102;
    public final static transient String BUSINESS_PROCESS = "xsys";
    public final static transient int FUNCTIONALITY = 8;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 2;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {MxXsys00800102 .class, QueueStatusReportRequest.class, ReportCriteriav2.class, ReportOptionCode.class, SwBooleanIndicator.class };
    public final static transient String NAMESPACE = "urn:swift:xsd:xsys.008.001.02";

    public MxXsys00800102() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxXsys00800102(final String xml) {
        this();
        MxXsys00800102 tmp = parse(xml);
        xsys00800102 = tmp.getXsys00800102();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxXsys00800102(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the xsys00800102 property.
     * 
     * @return
     *     possible object is
     *     {@link QueueStatusReportRequest }
     *     
     */
    public QueueStatusReportRequest getXsys00800102() {
        return xsys00800102;
    }

    /**
     * Sets the value of the xsys00800102 property.
     * 
     * @param value
     *     allowed object is
     *     {@link QueueStatusReportRequest }
     *     
     */
    public MxXsys00800102 setXsys00800102(QueueStatusReportRequest value) {
        this.xsys00800102 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxXsys00800102 parse(String xml) {
        return ((MxXsys00800102) MxReadImpl.parse(MxXsys00800102 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxXsys00800102 parse(String xml, MxRead parserImpl) {
        return ((MxXsys00800102) parserImpl.read(MxXsys00800102 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxXsys00800102 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxXsys00800102 message
     * @return
     *     a new instance of MxXsys00800102
     */
    public final static MxXsys00800102 fromJson(String json) {
        return AbstractMX.fromJson(json, MxXsys00800102 .class);
    }

}
