
package com.prowidesoftware.swift.model.mx.sys;

import com.prowidesoftware.swift.model.MxSwiftMessage;
import com.prowidesoftware.swift.model.mx.AbstractMX;
import com.prowidesoftware.swift.model.mx.MxRead;
import com.prowidesoftware.swift.model.mx.MxReadImpl;
import com.prowidesoftware.swift.model.mx.sys.dic.NonDeliveryWarningXsys01000102;
import com.prowidesoftware.swift.model.mx.sys.dic.OverdueWarningXsys01000102;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.xml.bind.annotation.*;


/**
 * Class for xsys.010.001.02 ISO 20022 message.
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Document", propOrder = {
    "xsys01000102"
})
@XmlRootElement(name = "Document", namespace = "urn:swift:xsd:xsys.010.001.02")
public class MxXsys01000102
    extends AbstractMX
{

    @XmlElement(name = "xsys.010.001.02", required = true)
    protected NonDeliveryWarningXsys01000102 xsys01000102;
    public final static transient String BUSINESS_PROCESS = "xsys";
    public final static transient int FUNCTIONALITY = 10;
    public final static transient int VARIANT = 1;
    public final static transient int VERSION = 2;
    @SuppressWarnings("rawtypes")
    public final static transient Class[] _classes = new Class[] {MxXsys01000102 .class, NonDeliveryWarningXsys01000102 .class, OverdueWarningXsys01000102.class };
    public final static transient String NAMESPACE = "urn:swift:xsd:xsys.010.001.02";

    public MxXsys01000102() {
        super();
    }

    /**
     * Creates the MX object parsing the parameter String with the XML content
     * 
     */
    public MxXsys01000102(final String xml) {
        this();
        MxXsys01000102 tmp = parse(xml);
        xsys01000102 = tmp.getXsys01000102();
    }

    /**
     * Creates the MX object parsing the raw content from the parameter MxSwiftMessage
     * 
     */
    public MxXsys01000102(final MxSwiftMessage mxSwiftMessage) {
        this(mxSwiftMessage.message());
    }

    /**
     * Gets the value of the xsys01000102 property.
     * 
     * @return
     *     possible object is
     *     {@link NonDeliveryWarningXsys01000102 }
     *     
     */
    public NonDeliveryWarningXsys01000102 getXsys01000102() {
        return xsys01000102;
    }

    /**
     * Sets the value of the xsys01000102 property.
     * 
     * @param value
     *     allowed object is
     *     {@link NonDeliveryWarningXsys01000102 }
     *     
     */
    public MxXsys01000102 setXsys01000102(NonDeliveryWarningXsys01000102 value) {
        this.xsys01000102 = value;
        return this;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(Object that) {
        return EqualsBuilder.reflectionEquals(this, that);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public String getBusinessProcess() {
        return BUSINESS_PROCESS;
    }

    @Override
    public int getFunctionality() {
        return FUNCTIONALITY;
    }

    @Override
    public int getVariant() {
        return VARIANT;
    }

    @Override
    public int getVersion() {
        return VERSION;
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML
     * 
     */
    public static MxXsys01000102 parse(String xml) {
        return ((MxXsys01000102) MxReadImpl.parse(MxXsys01000102 .class, xml, _classes));
    }

    /**
     * Creates the MX object parsing the raw content from the parameter XML with injected read implementation
     * @since 9.0.1
     * 
     * @param parserImpl an MX unmarshall implementation
     */
    public static MxXsys01000102 parse(String xml, MxRead parserImpl) {
        return ((MxXsys01000102) parserImpl.read(MxXsys01000102 .class, xml, _classes));
    }

    @Override
    public String getNamespace() {
        return NAMESPACE;
    }

    @Override
    @SuppressWarnings("rawtypes")
    public Class[] getClasses() {
        return _classes;
    }

    /**
     * Creates an MxXsys01000102 messages from its JSON representation.
     * <p>
     * For generic conversion of JSON into the corresponding MX instance 
     * see {@link AbstractMX#fromJson(String)}
     * 
     * @since 7.10.2
     * 
     * @param json a JSON representation of an MxXsys01000102 message
     * @return
     *     a new instance of MxXsys01000102
     */
    public final static MxXsys01000102 fromJson(String json) {
        return AbstractMX.fromJson(json, MxXsys01000102 .class);
    }

}
